;---
;--- Ekran z remisem
;--- RUN=$1BAC
;---

 opt h-
 org $0800

scr32 equ %00111101	;obraz waski    *-screen 32b
pm    equ $0000

Player0_PositionX equ $d000
Player1_PositionX equ $d001
Player2_PositionX equ $d002
Player3_PositionX equ $d003

Missile0_PositionX equ $d004
Missile1_PositionX equ $d005
Missile2_PositionX equ $d006
Missile3_PositionX equ $d007

Player0_Size equ $d008
Player1_Size equ $d009
Player2_Size equ $d00a
Player3_Size equ $d00b

Missiles_Size equ $d00c

Player0_Missile0_Color0_PM0 equ $d012
Player1_Missile1_Color1_PM1 equ $d013
Player2_Missile2_Color2_PM2 equ $d014
Player3_Missile3_Color3_PM3 equ $d015

Playfield_Color0_PF0 equ $d016
Playfield_Color1_PF1 equ $d017
Playfield_Color2_PF2 equ $d018
Playfield_Color3_PF3 equ $d019
Background_BAK       equ $d01a

PRIOR_GTIACTL equ $d01b
CHARBASE equ $d409

adr equ $f0
dst equ adr+2

clock equ $00
rejA  equ clock+1
rejX  equ rejA+1
rejY  equ rejX+1

player equ $fc20

;--
fnt2  ins 'remis.fnt',0,122*8

*--- wciskamy troche kodu, aby wyrownac do pelnego adresu
wait lda clock
 cmp clock
 beq *-2
 dex
 bne wait
 rts

ClearPmg lda #0
 ldy #7
clr sta $d000,y
 dey
 bpl clr

 tay
cl sta pm+$300,y
 sta pm+$400,y
 sta pm+$500,y
 sta pm+$600,y
 sta pm+$700,y
 iny
 bne cl
 rts
 
tadr dta a(text,text+320,text+640,text+960)
*---

fnt   ins 'remis_al.fnt',0,212*8

fnt_draw equ fnt+1024

text2 ins 'remis_al.scr',0,19*32
      ins 'remis_al.scr',21*32,4*32

text  ins 'remis.scr'
      ins 'remis_al.scr',0,10*32

;--
ant dta b($44),a(text2)
 dta b(4,4,4,4,4,4,4,4,$84)
 dta b(4,4,4,4,4,4,4,4,4)
 dta d'pp',b(4,4,4,4)
 dta b($41),a(ant)
;--

pmg
 dta b($00,$00,$00,$00,$80,$80,$00,$00,$88,$B8,$A8,$A8)
 dta b($BC,$EE,$EE,$EE,$CF,$CF,$CF,$CF,$CC,$CC,$88,$88,$88,$88,$88,$98)
 dta b($B8,$B8,$88,$88,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$CC,$88,$88,$88,$88)
 dta b($88,$08,$08,$08,$08,$08,$08,$08,$0C,$0C)

 dta b($00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$00)
 dta b($00,$00,$00,$FC,$3E,$3E,$7F,$7F,$FF,$FF,$7F,$7F,$7F,$7F,$3F,$3F)
 dta b($32,$32,$00,$00,$BE,$BE,$BE,$FE,$BF,$BF,$BE,$BE,$7E,$7E,$5D,$5C)
 dta b($1F,$00,$00,$00,$00,$00,$00,$00,$00,$00)

 dta b($08,$08,$08,$08,$1C,$1C,$3E,$3E,$7F,$7F,$7F,$7F)
 dta b($FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$7F,$7F,$7F,$7F,$7F,$7F)
 dta b($5F,$5F,$7F,$7F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$7F,$7F,$7F,$7E)
 dta b($7F,$7F,$77,$7F,$7F,$7F,$7F,$7F,$FF,$00)

 dta b($00,$00,$00,$00,$00,$00,$00,$00,$00,$00,$1C,$1C)
 dta b($3F,$BE,$FE,$FE,$44,$44,$00,$00,$DE,$9E,$1E,$1E,$1E,$1E,$2E,$6F)
 dta b($E7,$E7,$80,$80,$7C,$7C,$7E,$7E,$FF,$FF,$FF,$FF,$7E,$7E,$80,$80)
 dta b($7E,$7E,$FC,$FC,$00,$00,$00,$00,$00,$00)

 dta b($1C,$1C,$2E,$2E,$FF,$FF,$3F,$3F,$7F,$7F,$7F,$7F)
 dta b($7F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$7F,$7F,$7F,$7F,$7F,$7F)
 dta b($7F,$3F,$7F,$7F,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$FF,$3F,$7F,$7F,$7F)
 dta b($7f,$7f,$00,$00,$00,$00,$00,$00,$00,$00)

;--
main
;- init PMG
 ldx #1
 jsr wait

 lda #$40
 sta $d40e

 jsr ClearPmg
 
 lda >pm
 sta $d407
 lda #3
 sta $d01d		;PMCTL - wyswietlac duchy i pociski

; sei			;wylaczenie przerwan
; lda #0
; sta $d40e
; lda #$fe		;wylaczenie ROM-u
; sta $d301
 
 mwa #nmi $fffa

ofs equ 100
 
 ldy #0
 sty tim
cp lda pmg,y
 sta pm+$300+ofs,y
 lda pmg+54*1,y
 sta pm+$400+ofs,y
 lda pmg+54*2,y
 sta pm+$500+ofs,y
 lda pmg+54*3,y
 sta pm+$600+ofs,y
 lda pmg+54*4,y
 sta pm+$700+ofs,y
 iny
 cpy #54
 bne cp
 
 lda #$c0
 sta $d40e

*--- 
loop
 lda clock
 sta wai_s+1

wai_ lda $d40b
 cmp #88
 bne wai_s

 jsr player+6

wai_s lda #0
 cmp clock
 beq wai_

 jsr player+3 
 
klawisz inc tim
 lda #0
tim equ *-1
 cmp #200
 bcs quit
 
 lda $d010	;trig0
 beq quit
 lda $d011	;trig1
 beq quit

 lda $d20f
 and #4
 bne loop
 
quit
 ldx #2
 jsr wait

 jsr ClearPmg

 lda #$b2
 sta k0+1
 lda #8
 sta k1+1
 lda #4
 sta k2+1
 lda #2
 sta k3+1
 ldx #1		;i ciemniutko
 jsr wait
 lda #$b0
 sta k0+1
 sta k1+1
 sta k2+1
 sta k3+1

 ldx #1
 jsr wait
 
 lda #0
 sta $d400
 lda #$40
 sta $d40e
 rts		;wyjscie

;---
;---

dli
 sta rejA
 stx rejX
 sty rejY
 
 :5 sta $d40a
 jsr wait68
 
; line=85

 lda #$08
 ldx #$0E
 ldy #$06
 sta Playfield_Color0_PF0
 stx Playfield_Color1_PF1
 sty Playfield_Color3_PF3
 jsr wait50

 :2 jsr wait68

; line=88

 lda >fnt
 sta $d409
 :3 jsr _rts

; line=89

 lda #$70
 ldx #$18
 sta Playfield_Color0_PF0
 stx Playfield_Color3_PF3
 :3 nop
 jsr wait50
 
; line=90

 jsr wait68

; line=91

 lda #$72
 sta Player1_Missile1_Color1_PM1
 jsr _rts
 jsr wait50

; line=92

 jsr wait68

; line=93

 lda #$2A
 sta Playfield_Color1_PF1
 jsr _rts
 jsr wait50

; line=94

 :2 jsr wait68
 jsr wait42
 jsr wait68

; line=98
 lda #$01
 ldx #$99
 ldy #$A8
 sta Player3_Size
 stx Player3_PositionX
 sty Missile3_PositionX
 lda #$E4
 sta Player3_Missile3_Color3_PM3
 jsr _rts
 ldx #$F2
 lda #$F6
 stx $d016
 sta $d017
 ldx #$70
 lda #$86
 stx $d016
 sta $d017
 :4 nop

; line=99

 lda #$86
 sta Playfield_Color1_PF1
 :2 jsr _rts
 :3 nop
 ldx #$F2
 lda #$F6
 stx $d016
 sta $d017
 ldx #$70
 lda #$86
 stx $d016
 sta $d017
 :4 nop

; line=100

 :2 jsr _rts
 jsr _rts
 ldx #$F2
 lda #$F6
 stx $d016
 sta $d017
 ldx #$70
 lda #$86
 stx $d016
 sta $d017
 :4 nop

; line=101

 lda #$54
 sta Missiles_Size
 :2 jsr _rts
 :3 nop
 ldx #$F2
 lda #$F6
 stx $d016
 sta $d017
 ldx #$70
 lda #$86
 stx $d016
 sta $d017
 :4 nop

; line=102

 lda #$74
 ldx #$9F
 ldy #$F6
 sta Missiles_Size
 stx Missile2_PositionX
 sty Player2_Missile2_Color2_PM2
 jsr _rts
 :3 nop
 ldx #$F2
 lda #$F6
 stx $d016
 sta $d017
 ldx #$70
 lda #$86
 stx $d016
 sta $d017
 :4 nop

; line=103

 :2 jsr _rts
 jsr _rts
 ldx #$F2
 lda #$F6
 stx $d016
 sta $d017
 ldx #$70
 lda #$86
 stx $d016
 sta $d017
 :4 nop

; line=104

 jsr wait42

; line=105

 :3 jsr _rts
 ldx #$F2
 lda #$F6
 stx $d016
 sta $d017
 ldx #$70
 lda #$86
 stx $d016
 sta $d017
 :4 nop

; line=106

 :3 jsr _rts
 ldx #$F2
 lda #$F6
 stx $d016
 sta $d017
 ldx #$70
 lda #$86
 stx $d016
 sta $d017
 :4 nop

; line=107

 lda #$14
 sta Player0_Missile0_Color0_PM0
 :2 jsr _rts
 :3 nop
 ldx #$F2
 lda #$F6
 stx $d016
 sta $d017
 ldx #$70
 lda #$86
 stx $d016
 sta $d017
 :4 nop

; line=108

 lda #$44
 sta Missiles_Size
 :2 jsr _rts
 :3 nop
 ldx #$F2
 lda #$F6
 stx $d016
 sta $d017
 ldx #$70
 lda #$86
 stx $d016
 sta $d017
 :4 nop

; line=109

 :3 jsr _rts
 ldx #$F2
 lda #$F6
 stx $d016
 sta $d017
 ldx #$70
 lda #$86
 stx $d016
 sta $d017
 :4 nop

; line=110

 :3 jsr _rts
 ldx #$F2
 lda #$F6
 stx $d016
 sta $d017
 ldx #$70
 lda #$86
 stx $d016
 sta $d017
 :4 nop

; line=111

 :3 jsr _rts
 ldx #$F2
 lda #$F6
 stx $d016
 sta $d017
 ldx #$70
 lda #$86
 stx $d016
 sta $d017
 :4 nop

; line=112

 jsr wait42
 
; line=113

 :3 jsr _rts
 ldx #$F2
 lda #$F6
 stx $d016
 sta $d017
 ldx #$70
 lda #$86
 stx $d016
 sta $d017
 :4 nop

; line=114

 :3 jsr _rts
 ldx #$F2
 lda #$F6
 stx $d016
 sta $d017
 ldx #$70
 lda #$86
 stx $d016
 sta $d017
 :4 nop

; line=115

 :3 jsr _rts
 ldx #$F2
 lda #$F6
 stx $d016
 sta $d017
 ldx #$70
 lda #$86
 stx $d016
 sta $d017
 :4 nop

; line=116

 :3 jsr _rts
 ldx #$F2
 lda #$F6
 stx $d016
 sta $d017
 ldx #$70
 lda #$86
 stx $d016
 sta $d017
 :4 nop

; line=117

 :3 jsr _rts
 ldx #$F2
 lda #$F6
 stx $d016
 sta $d017
 ldx #$70
 lda #$86
 stx $d016
 sta $d017
 :4 nop

; line=118

 :3 jsr _rts
 ldx #$F2
 lda #$F6
 stx $d016
 sta $d017
 ldx #$70
 lda #$86
 stx $d016
 sta $d017
 :4 nop

; line=119

 lda #$A8
 ldx #$F2
 sta Missile2_PositionX
 stx Player2_Missile2_Color2_PM2
 :2 jsr _rts
 ldx #$F2
 lda #$F6
 stx $d016
 sta $d017
 ldx #$70
 lda #$86
 stx $d016
 sta $d017
 :4 nop

; line=120

 lda #$00
 ldx #$0E
 ldy #$9B
 sta Playfield_Color1_PF1
 stx Playfield_Color2_PF2
 sty Player2_PositionX
 :2 jsr _rts

; line=121

 :3 nop
 jsr _rts
 jsr _rts
 jsr _rts
 lda #$F2
 sta $d016
 ldx #$70
 nop
 stx $d016
 jsr _rts

; line=122

 lda #$72
 ldx #$F4
 sta Playfield_Color3_PF3
 stx Player3_Missile3_Color3_PM3
 :3 nop
 jsr _rts
 jsr _rts
 lda #$F2
 sta $d016
 ldx #$70
 nop
 stx $d016
 jsr _rts

; line=123

 lda #$9E
 ldx #$F6
 sta Player2_PositionX
 stx Player2_Missile2_Color2_PM2
 :3 nop
 jsr _rts
 jsr _rts
 lda #$F2
 sta $d016
 ldx #$70
 nop
 stx $d016
 jsr _rts

; line=124

 lda #$88
 sta Player0_Missile0_Color0_PM0
 :2 jsr _rts
 jsr _rts
 lda #$F2
 sta $d016
 ldx #$70
 nop
 stx $d016
 jsr _rts

; line=125

 :2 nop
 jsr _rts
 jsr _rts
 jsr _rts
 lda #$F2
 sta $d016
 ldx #$70
 nop
 stx $d016
 jsr _rts

; line=126

 :3 nop
 jsr _rts
 jsr _rts
 jsr _rts
 lda #$F2
 sta $d016
 ldx #$70
 nop
 stx $d016
 jsr _rts

; line=127

 :3 nop
 jsr _rts
 jsr _rts
 jsr _rts
 lda #$F2
 sta $d016
 ldx #$70
 nop
 stx $d016
 jsr _rts

; line=128

 lda #$F8
 ldx #$EA
 ldy #$EA
 sta Playfield_Color3_PF3
 stx Player0_Missile0_Color0_PM0
 sty Player2_Missile2_Color2_PM2
 lda #$F2
 sta Player3_Missile3_Color3_PM3
 :9 nop

; line=129

 lda #$F4
 sta Player3_Missile3_Color3_PM3
 :2 jsr _rts
 jsr _rts
 lda #$F2
 sta $d016
 ldx #$70
 nop
 stx $d016
 jsr _rts

; line=130

 lda #$28
 sta Playfield_Color2_PF2
 :2 jsr _rts
 jsr _rts
 lda #$F2
 sta $d016
 ldx #$70
 nop
 stx $d016
 jsr _rts

; line=131

 :3 nop
 jsr _rts
 jsr _rts
 jsr _rts
 lda #$F2
 sta $d016
 ldx #$70
 nop
 stx $d016
 jsr _rts

; line=132

 lda #$72
 ldx #$88
 ldy #$F6
 sta Playfield_Color3_PF3
 stx Player0_Missile0_Color0_PM0
 sty Player2_Missile2_Color2_PM2
 jsr _rts
 jsr _rts
 lda #$F2
 sta $d016
 ldx #$70
 nop
 stx $d016
 jsr _rts

; line=133

 :3 nop
 jsr _rts
 jsr _rts
 jsr _rts
 lda #$F2
 sta $d016
 ldx #$70
 nop
 stx $d016
 jsr _rts

; line=134

 lda #$0E
 sta Playfield_Color2_PF2
 :2 jsr _rts
 jsr _rts
 lda #$F2
 sta $d016
 ldx #$70
 nop
 stx $d016
 jsr _rts

; line=135
 
 :3 nop
 jsr _rts
 jsr _rts
 jsr _rts
 lda #$F2
 sta $d016
 ldx #$70
 nop
 stx $d016
 jsr _rts

; line=136

 lda #$F2
 sta Player2_Missile2_Color2_PM2
 :3 jsr _rts

; line=137

 lda #$0E
 ldx #$00
 ldy #$18
 sta Playfield_Color1_PF1
 stx Playfield_Color2_PF2
 sty Playfield_Color3_PF3
 lda #$04
 sta Missiles_Size
 jsr _rts
 :3 nop
 lda #$F2
 sta $d016
 ldx #$70
 nop
 stx $d016
 jsr _rts

; line=138

 lda #$28
 sta Playfield_Color0_PF0
 jsr _rts
 jsr wait50

 :5 jsr wait68

; line=144

 lda #$04
 ldx >fnt+1*$400
 sta Playfield_Color0_PF0
 stx CHARBASE
 :3 nop
 :2 jsr _rts

; line=145

 lda #$06
 sta Player1_Missile1_Color1_PM1
 jsr _rts
 jsr wait50

; line=146

 lda >fnt_draw
 sta $d409
 lda #0
 sta $d016
 lda #$ca
 sta $d017
 lda #0	$b6
 sta $d018
 
 :4 sta $d40a
 lda #$b6
 sta $d018

 lda rejA
 ldx rejX
 ldy rejY
 rti
 
; jmp LOOP
 
 
;--
nmi bit $d40f
 bpl vbl

vdli jmp dli
 
vbl sta rA+1
 stx rX+1
 sty rY+1
 sta $d40f
 
 inc clock
 mwa #ant $d402
 lda #scr32		;ustawienie szerokosci obrazu
 sta $d400

znak lda >fnt+$400*$00
 sta CHARBASE
k0 lda #$B4
 sta Background_BAK
k1 lda #$0E
 sta Playfield_Color0_PF0
k2 lda #$08
 sta Playfield_Color1_PF1
k3 lda #$04
 sta Playfield_Color3_PF3

 lda #$00
 sta Playfield_Color2_PF2
 sta Player3_Size
 sta Player2_Size
 lda #8 
 sta Player2_Missile2_Color2_PM2
 lda #4
 sta PRIOR_GTIACTL
 sta Player0_Missile0_Color0_PM0
 lda #$60
 sta Missile1_PositionX
 lda #$06
 sta Player1_Missile1_Color1_PM1
 lda #$01
 sta Player1_Size
 sta Player0_Size
 lda #$44
 sta Missiles_Size
 lda #$51
 sta Player1_PositionX
 lda #$A5
 sta Missile3_PositionX
 lda #$F2
 sta Player3_Missile3_Color3_PM3
 lda #$9E
 sta Player3_PositionX
 lda #$A1
 sta Missile2_PositionX
 lda #$9A
 sta Player2_PositionX
 lda #$5E
 sta Missile0_PositionX
 lda #$51
 sta Player0_PositionX

*--- anima 
 lda clock
 and #3
 bne vblQ
 
cnt lda #0
ani equ *-1
 and #3
 asl @
 tax
 mwa tadr,x adr
 mwa #text2 dst
 
 lda >fnt2
 cpx #6
 bne c_
 lda >fnt
c_ sta znak+1
 sta $d409

 ldy #0
mv0 lda (adr),y
 sta (dst),y
 iny
 bne mv0
 inc adr+1
 inc dst+1
 ldy #$3f
mv1 lda (adr),y
 sta (dst),y
 dey
 bpl mv1
 inc ani
 
vblQ

rA lda #0
rX ldx #0
rY ldy #0
 rti

;--

wait68
 jsr _rts
 :3 nop

wait50
 :4 nop

wait42
 :3 nop
 :2 jsr _rts
_rts rts

;--
; run main
