;--------------------------------;
*  Dyna Blaster - Engine v1.7.3  *
* by TeBe/Madteam (Tomasz Biela) * 
;--------------------------------; 

* tablica TSPRT
* wartosc <> 0 oznacza sprita
* wartosc = 0 oznacza brak sprita

* tablica DEATH 1 bajt - 8 bitow
* bit 0-wybuchy,1-gabki,2-zarowki

* pexpl - pojedyncze eksplozje
* pexm1 - eksplozja murku
* [csh+8]  - max bomb do postawienia
* [csh+9]  - max moc bomby
* [csh+10] - liczba postawionych bomb
* [csh+11] - czy oberwal
* [csh+12] - szybkosc bohatera
* [csh+13] - czy zebral czache
* [csh+14..15] - licznik do 30 sek. dla czaszek
* [csh+16..17] - mbmb, moc
* [csh+18] - sra bombami
* [csh+21.22] - kolor gracza
* [csh+23.24] - wyliczona pozycja x, y sprita na ekranie

* !!!
* !!! zawsze sprawdz czy adres 'dli', '_jump', 'joyc' jest na poczatku strony pamieci
* !!!

;--- rozgrywka do 5,4,3,2,1 zwyciestw, w zaleznosci ustawien wg Setup
;--- czaszki On/Off wg Setup

;---------------------;
* changes: 16.06.2004 *
;---------------------;

*- obszar pamieci $a800-$beff spakowany do pliku DUMP.DEF
*- w ten obszar rozpakowywany jest MSX

Player0_PositionX equ $d000
Player1_PositionX equ $d001
Player2_PositionX equ $d002
Player3_PositionX equ $d003

Missile0_PositionX equ $d004
Missile1_PositionX equ $d005
Missile2_PositionX equ $d006
Missile3_PositionX equ $d007

Player0_Size equ $d008
Player1_Size equ $d009
Player2_Size equ $d00a
Player3_Size equ $d00b

Missiles_Size equ $d00c

Player0_Missile0_Color0_PM0 equ $d012
Player1_Missile1_Color1_PM1 equ $d013
Player2_Missile2_Color2_PM2 equ $d014
Player3_Missile3_Color3_PM3 equ $d015

bum     equ $0200       ; efekty dzwiekowe
tik     equ $b300

tproc	equ $d800	;nr proc obslugi
tsprt	equ tproc+256	;tab aktywnosci
tdela	equ tsprt+256	;opuznienie
tcloc	equ tdela+256	;zegar
tsekw	equ tcloc+256	;ile sekwencji
tlicz	equ tsekw+256	;licznik sekwencji
l_anm	equ tlicz+256	;adres tablicy
h_anm	equ l_anm+256	;z klatkami animki
l_adr	equ h_anm+256	;adres znaku
h_adr	equ l_adr+256	;na ekranie

tposy	equ h_adr+256	;nr znaku
tcont	equ tposy+256	;nr proc po koncu anm
death	equ tcont+256	;smiercionosne pola
czyje	equ death+256	;kto co postawil
bonus	equ czyje+256	;bonusy

lfnt	equ bonus+256
hfnt	equ lfnt+256

tabX	equ hfnt+256
tabY	equ tabX+256

tAruch	equ tabY+256	;0 or 1
;	equ +256	;0 or 1 or 2
;	equ +256	;0 or 1 or 2 or 3
	
tSbc16	equ tAruch+768	;tAruch jest rozpisany, zajmuje 768 bajtow
tAdc16	equ tSbc16+256

marker	equ tAdc16+256
tadd	equ marker+256	;(40)

scr	equ $f201	;($200)

bufor   equ $f500       ;($400)

player	equ $fc20	;adres playera TMC
player2 equ $c100       ;ostatni fragment playera TMC

pm	equ $0000       ;obszar $300..$700 zajety, ale moze byc tam bufor na czas rozpakowania
proc	equ $0800       ;tutaj rozpakowuje dodatkowe ekrany, oprocz ostatniego

menuPrg  equ $1ad0      ;adresy uruchomien dodatkowych ekranow
roundPrg equ $139e
remisPrg equ $1bac
winnPrg  equ $e5e2

muza	equ $a800	; adres rozpakowanego modulu TMC ($a800-$c100)

gab_ex	equ $b000
zar_ex	equ gab_ex+$800

jingle  equ $c400
title   equ $cc00

fnt2	equ $6c00

zar  equ $9000
gab  equ $9800
fnt  equ $a000
buf0 equ $a800 ;1 pmg
buf1 equ $ac00 ;2 pmg

time equ $00	/1
shp  equ time+1 /1
pom  equ shp+1  /2
hlp  equ pom+2  /2
rob  equ hlp+2  /1
tmp  equ rob+1  /2
moc  equ tmp+2  /1	;moc bomby
posy equ moc+1	/1
bak  equ posy+1	/2
mbmb equ bak+2	/1	;max bomb
ibmb equ mbmb+1 /1	;ilosc bomb
hits equ ibmb+1 /1	;zycie
skul equ hits+1 /1	;czy czacha

x  equ skul+1	/1
y  equ x+1	/1
sx equ y+1	/1
sy equ sx+1	/1

_s equ sy+1 /1
_m equ _s+1 /1

msk  equ _m+1    /2
char equ msk+2   /1
fram equ char+1  /1
kier equ fram+1  /1
tRuch equ kier+1 /4
bshp equ tRuch+4 /64	;bufor shape

dol equ 0
pra equ 3
lew equ 6
gor equ 9
wyb equ 12
wy_scr equ 13	 ;wysokosc ekranu
sz_scr equ 16	 ;szerokosc ekranu

_mur1  equ 2	 ;miekki
_nic   equ 4
_black equ 6
_mur2  equ 0+$80 ;twardy
_bmb   equ 16
_bom   equ $54	 ;ikona bomby
_fir   equ $58	 ;ikona ognia
_cza   equ $5c	 ;ikona czachy

colPlay1 equ $f2 ;kolor gracza 1
colPlay2 equ $84 ;kolor gracza 2

_sta equ 0	 ;indeksy do tablicy procedur "lproc" i "hproc"
_wyb equ 1
_clr equ 2
_st2 equ 3
_cm1 equ 4
_cex equ 5
_st3 equ 6
_clB equ 7  	 ;7 wpis w tablicy "lproc" "hproc"

siz equ 26	 ;rozmiar tablicy opisujacej gracza
len equ 29	 ;rozmiar tablicy opisujacej sprita programowego

;-------;
* INTRO *
;-------;
 
 opt h-
 org $2970
 
 ins 'intro2\pack.obx'

;-----------------------------;
* procedurki na strone zerowa *
;-----------------------------;
subZer00 equ $70

 opt o-
 org subZer00

tmp_ lda $ffff,y
 sta bshp,y
bak_ lda $ffff,y
 sta bshp+8,y

tmp2_ lda $ffff,y
 sta bshp+32,y
bak2_ lda $ffff,y
 sta bshp+40,y

tmp3_ lda $ffff,y
 sta bshp+16,y
bak3_ lda $ffff,y
 sta bshp+24,y

tmp4_ lda $ffff,y
 sta bshp+48,y
bak4_ lda $ffff,y
 sta bshp+56,y
 dey
 bpl tmp_
 jmp modyf

;---

subZer01
tm_ lda $ffff,y
 sta bshp,y
ba_ lda $ffff,y
 sta bshp+24,y

tm2_ lda $ffff,y
 sta bshp+8,y
ba2_ lda $ffff,y
 sta bshp+32,y

tm3_ lda $ffff,y
 sta bshp+16,y
ba3_ lda $ffff,y
 sta bshp+40,y

 dey
 bpl tm_
 jmp modyf2

;---

subZer02
r0 lda bshp,y
ms and $ffff,y
hl ora $ffff,y
_tm sta $ffff,y

 lda bshp+24,y
ms2 and $ffff,y
hl2 ora $ffff,y
_ba sta $ffff,y
 dey
 bpl r0
 jmp fza

;---

 opt h+o+
 
;--- rozpakowuje player i grafike
;--- muzyczki przenosi pod ROM
;---
 org $2000
 
depack lda 20
 cmp 20
 beq *-2

 sei
 lda #0
 sta $d40e
 sta $d400
 sta 559
 lda #$fe
 sta $d301
 
 mwa #pack_jin s_+1 
 lda >jingle
 ldx #8
 jsr move_
 mwa #pack_tit s_+1 
 lda >title
 ldx #4
 jsr move_

 mwa #pack_tmc inputPointer
 mwa #player outputPointer
 jsr inflate_

 mwa #pack_tmc2 inputPointer
 mwa #player2 outputPointer
 jsr inflate_

 mwa #pack_spr inputPointer
 mwa #zar outputPointer
 jsr inflate_

 lda #$ff
 sta $d301
 lda #$40
 sta $d40e
 cli
 rts

pack_tmc  ins 'tmc/tmcplay.def'
pack_tmc2 ins 'tmc/tmcplay2.def'
pack_spr  ins 'pack/pack.def'

pack_tit  ins 'msx/msx.def'
pack_jin  ins 'msx/jingle.def'

move_ sta d_+2
 ldy #0
s_ lda $ffff,y
d_ sta $ff00,y
 iny
 bne s_
 inc s_+2
 inc d_+2
 dex
 bne s_
 rts

;---
;---
 org $6500
inflate_ ins 'inflate/inflate.obx'

 ini depack
 
;---
;---

 org $2800
menuPck  ins 'menu/menu.def'
roundPck ins 'round/round.def'
remisPck ins 'draw_game/dremis.def'
winnPck  ins 'winn/winn.def'
tablPck  ins 'winn/tablice.def'
dumpPck  ins 'dump.def'

;---
 org fnt2
;---
 ins 'panel/panel_dl.fnt',0,90*8

;--------------------------------------------;
* procedurki do przepisania na strone zerowa *
;--------------------------------------------;
; subZer00
;----------
subZer00_
 lda $ffff,y
 sta bshp,y
 lda $ffff,y
 sta bshp+8,y

 lda $ffff,y
 sta bshp+32,y
 lda $ffff,y
 sta bshp+40,y

 lda $ffff,y
 sta bshp+16,y
 lda $ffff,y
 sta bshp+24,y

 lda $ffff,y
 sta bshp+48,y
 lda $ffff,y
 sta bshp+56,y

 dey
 bpl subZer00_
 jmp modyf

;---

subZer01_
 lda $ffff,y
 sta bshp,y
 lda $ffff,y
 sta bshp+24,y

 lda $ffff,y
 sta bshp+8,y
 lda $ffff,y
 sta bshp+32,y

 lda $ffff,y
 sta bshp+16,y
 lda $ffff,y
 sta bshp+40,y

 dey
 bpl subZer01_
 jmp modyf2

;---

subZer02_
 lda bshp,y
 and $ffff,y
 ora $ffff,y
 sta $ffff,y

 lda bshp+24,y
 and $ffff,y
 ora $ffff,y
 sta $ffff,y
 dey
 bpl subZer02_
 jmp fza

free

;---------;
* TABLICE *
;---------;

 opt o-
 org $b700

Lcyfra dta d'!!!!!!!!!!""""""""""##########$$$$$$$$$$%%%%%%%%%%&&&&&&&&&&'*
Pcyfra dta d'!"#$%&''()*!"#$%&''()*!"#$%&''()*!"#$%&''()*!"#$%&''()*!"#$%&''()*'*

exs dta b($4c,$4a,$48,$46,$48,$4a,$4c,_nic)

expi dta b($3c,$3a,$38,$36,$38,$3a,$3c,_nic)
expr dta b($44,$42,$40,$3e,$40,$42,$44,_nic)

exg dta b(28,26,24,22,24,26,28,_nic)
exd dta b(44,42,40,38,40,42,44,_nic)
exp dta b(36,34,32,30,32,34,36,_nic)
exl dta b(52,50,48,46,48,50,52,_nic)

exm1a dta b($02,$4e,$50,$52,_nic)

exiko dta b($08,$0a,$0c,$0e,$0c,$0a,$08,_nic)

lshp dta l(0,$c0,0,$180,$240,$300)
hshp dta h(0,$c0,0,$180,$240,$300)

trg dta b(0,48,96,144)
tlf dta b(144,96,48,0)
tstp dta d'        '
tdw dta b(0,2,4,6,8,10,12,14)
tup dta b(14,12,10,8,6,4,2,0)

PolPos dta b(0,0,48,40)
       dta b(48,0,0,40)
       dta b(48,40,0,0)
       dta b(0,40,48,0)


 opt o-
 org $9e00
 
map
 dta d'               '*,b(_black)
 dta d' $$$$$$$$$$$$$ '*,b(_black)
 dta d' $ $ $ $ $ $ $ '*,b(_black)
 dta d' $$$$$$$$$$$$$ '*,b(_black)
 dta d' $ $ $ $ $ $ $ '*,b(_black)
 dta d' $$$$$$$$$$$$$ '*,b(_black)
 dta d' $ $ $ $ $ $ $ '*,b(_black)
 dta d' $$$$$$$$$$$$$ '*,b(_black)
 dta d' $ $ $ $ $ $ $ '*,b(_black)
 dta d' $$$$$$$$$$$$$ '*,b(_black)
 dta d' $ $ $ $ $ $ $ '*,b(_black)
 dta d' $$$$$$$$$$$$$ '*,b(_black)
 dta d'               '*,b(_black)

mapBuf
 dta d'               '*,b(_black)
 dta d' $$$$$$$$$$$$$ '*,b(_black)
 dta d' $ $ $ $ $ $ $ '*,b(_black)
 dta d' $$$$$$$$$$$$$ '*,b(_black)
 dta d' $ $ $ $ $ $ $ '*,b(_black)
 dta d' $$$$$$$$$$$$$ '*,b(_black)
 dta d' $ $ $ $ $ $ $ '*,b(_black)
 dta d' $$$$$$$$$$$$$ '*,b(_black)
 dta d' $ $ $ $ $ $ $ '*,b(_black)
 dta d' $$$$$$$$$$$$$ '*,b(_black)
 dta d' $ $ $ $ $ $ $ '*,b(_black)
 dta d' $$$$$$$$$$$$$ '*,b(_black)
 dta d'               '*,b(_black)

bar ins 'panel/panel_dl.scr',32,96

;---
;---

 opt o+
 org free

lproc dta l(anmst,explo,clear,anms2,clrm1,clexp,anms3,clearBuum)
hproc dta h(anmst,explo,clear,anms2,clrm1,clexp,anms3,clearBuum)

ltexpa dta l(exs,exg,exp,exd,exl,expi,expr)
htexpa dta h(exs,exg,exp,exd,exl,expi,expr)

tikon dta a(aibmb,aifir,aicza)

abomb dta d'02420242024'
aibmb dta b(_bom,_bom+2)
aifir dta b(_fir,_fir+2)
aicza dta b(_cza,_cza+2)

;--- kolejnosc animacji klatek bohatera
;---
tkol dta d'   !!!   """'

nul dta d'!"  $             '
csh dta d'    ',b(0),b(0),b(0),h(pm+$400),d'!"  $             '
    dta d'    ',b(48),b(40),b(2),h(pm+$600),d'!"  $             '

over brk

;---

ljmp dta l(0,0,0,0,0,p_dwrg,p_uprg,_rg_,0,p_dwlf,p_uplf,_lf_,0,_dw_,_up_,0)
;hjmp dta h(0,0,0,0,0,p_dwrg,p_uprg,_rg_,0,p_dwlf,p_uplf,_lf_,0,_dw_,_up_,0)

 :2 brk         ; aby 'joyc' wyrownac do pelnego adresu

;--- kolory (pole gry(4), gorny_panel(4), kolory_graczy)
maxCol
; dta b($f8,$c2,$38,$8,$a,$a6,$16,$f,colPlay1,colPlay2,colPlay1,colPlay2,colPlay1+6,colPlay2+$14)
 dta b($a,$a4,$24,6,$c8,$c,$b4,$f4,colPlay1,colPlay2,colPlay1,colPlay2,colPlay1+6,colPlay2+$14)
 dta b($74,$28,$88,$f8,$34)

free2

;---
;---

 opt o-
 org $bb00

;--- ANTIC
ant dta b($20,$44+$80),a(bar)
 dta b(4,4,$30+$80)

 dta b($c4),a(scr-1)
 dta b($c4),a(scr-1)
 dta b($c4),a(scr+31)
 dta b($c4),a(scr+31)
 dta b($c4),a(scr+63)
 dta b($c4),a(scr+63)
 dta b($c4),a(scr+95)
 dta b($c4),a(scr+95)
 dta b($c4),a(scr+127)
 dta b($c4),a(scr+127)
 dta b($c4),a(scr+159)
 dta b($c4),a(scr+159)
 dta b($c4),a(scr+191)
 dta b($c4),a(scr+191)
 dta b($c4),a(scr+223)
 dta b($c4),a(scr+223)
 dta b($c4),a(scr+255)
 dta b($c4),a(scr+255)
 dta b($c4),a(scr+287)
 dta b($c4),a(scr+287)
 dta b($c4),a(scr+319)
 dta b($c4),a(scr+319)
 dta b($c4),a(scr+351)
 dta b($c4),a(scr+351)
 dta b($c4),a(scr+383)
 dta b($c4),a(scr+383)
; dta b($c4),a(scr+415)
; dta b($c4),a(scr+415)
; dta b($c4),a(scr+447)
; dta b($c4),a(scr+447)
nulAnt dta b($41),a(ant)

;--- ksztalt mordek obok liczby zyc
;---
tabBar
 dta b($00,$00,$00,$00,$1C,$3E,$63,$1C,$36,$6B,$55,$55,$55,$4D,$5D,$6B)
 dta b($36,$1C,$00,$00,$00)

 dta b($00,$00,$00,$00,$00,$1C,$3E,$22,$41,$41,$41,$41,$3E,$3E,$00,$5D)
 dta b($5D,$00,$00,$00,$00)

 dta b($00,$00,$00,$00,$00,$1C,$3E,$3E,$7F,$6B,$6B,$7F,$00,$00,$00,$00)
 dta b($00,$00,$00,$00,$00)

 dta b($00,$00,$00,$00,$00,$00,$00,$1C,$3E,$2A,$2A,$3E,$00,$00,$00,$00)
 dta b($00,$00,$00,$00,$00)

temp :16 brk

k708 brk
k709 brk
k710 brk
k711 brk
_708 brk
_709 brk
_710 brk
_711 brk
m00  brk        ; kolor mordki #1
m01  brk        ; kolor mordki #2
h00  brk        ; kolor gracza #1
h01  brk        ; kolor gracza #2
h00_ brk
h01_ brk
pmCol :5 brk

;---
;---
 opt o+
 org free2

;--------------;
* MAIN PROGRAM *
;--------------;

main lda 20
 cmp 20
 beq *-2
 
 cld
 sei
 lda #0
 sta $d40e
 lda #$fe
 sta $d301

 jsr copy_SFX
 jsr nmi_null

; jsr init
; jsr iniHero

; lda #0
; sta 559
 
menu lda <title
 ldx >title
 jsr msxDepack

 lda #0
 jsr iniMsx

 lda <menuPck
 ldx >menuPck
 jsr rozpakuj

 lda #$4c
 sta player+3
 ldx ile_rund+1		;init wartosci ROUND i MODE
 dex
 ldy czacha+1
 jsr menuPrg
 
 mwa #dli vdli+1
 jsr nmi_null
 
 inx
 stx ile_rund+1
 sty czacha+1

;---

 jsr msxStop
 
;---

 lda #0
 sta poleposition+1

 lda #$bd	;modyfikacja adresu na "lda death,x"
 sta MassKill
 mwa #death MassKill+1

; lda $d40b
; bne *-3

 jsr wai

; sei
; lda #0
; sta $d40e
; sta $d400
; lda #$fe
; sta $d301

; mwa #nmi $fffa
; lda #$c0
; sta $d40e

nopek jsr iniZeroPage
 jsr init
; jsr iniHero

 lda #$ea		;NOP
 sta nopek
 sta nopek+1
 sta nopek+2

gra jsr iniGra

start
ile_rund lda #5
 sta rundA+1
 sta rundB+1
 
 lda <roundPck
 ldx >roundPck
 jsr rozpakuj
 
 ldx rundA+1
 lda #0
 jsr roundPrg   	;czyszcze ekran z pucharami, puchary pokazuja wygrane rundy
; jsr powrot
 jsr copy_proc2bufor
 
retry jsr dumpDepack
 jsr powrot
 
 jsr wai
 lda #$ff	;zatrzymanie enginu gry i czasu
 sta stop+1
 sta clock+1
 lda #0
 sta stop_hero+1

 jsr ClrSprt	; czyszczenie tablic spritow sprzetowych i programowych

 jsr mapClr
 jsr IniHero
 
 jsr losmur
 jsr iNIpRGSprt
 
 jsr map2scr
 lda #_black
 sta scr-1

;---------;
* fade in *
;---------;
; lda #$a0      ; init kolorow ekranu, paska menu, mordek
 
 ldy #18
fi lda maxcol,y
 and #$f0
 sta k708,y
 dey
 bpl fi

 ldy #15        ; plynne zapalenie kolorow obrazu
petel jsr wai

 ldx #18
p00 lda k708,x
 cmp maxCol,x
 beq p_Q
 inc k708,x
p_Q dex
 bpl p00

 dey
 bpl petel

 ldy #1
 sty maxAnm+1
 dey		;let's go
 sty stop+1
 sty clock+1
 sty _last_key
 lda #$ff
 sta stop_hero+1	;pozwol przenosic pozycje X graczy na ekran

 lda #128
 sta over

 jmp koniec
 
wai lda time
 cmp time
 beq *-2
 rts

;----------------------------------;
* Sprawdz bonus czy zostal zebrany *
;----------------------------------;
anms3 ldx tposy,y
 lda bonus,x
 bne anmst
 lda #_cm1
 sta tproc,y
 jmp anmq

;------------------------------------------;
* Sprawdz bombe czy ma wybuchnac wczesniej *
;------------------------------------------;
anms2 ldx tposy,y
 lda death,x
 and #1
 beq anmst
 lda tcont,y
 sta tproc,y
 jmp anmq

;--------------------;
* Animacja statyczna *
* procka uniwersalna *
;--------------------;
anmst ldx tcloc,y   ;zwieksz zegar
 inx
 txa
 sta tcloc,y

 cmp tdela,y   ;czy osiagnal wartosc
 bcc an_
 lda #0        ;ustaw zegar
 sta tcloc,y

 ldx tposy,y
 lda l_adr,x
 sta pom
 lda h_adr,x
 sta pom+1

 lda l_anm,y
 sta hlp
 lda h_anm,y
 sta hlp+1

 ldx anm+1
 ldy tlicz,x
 sty rob
 lda (hlp),y
 ldy #0
 sta (pom),y
 iny
 ora #1
 sta (pom),y

 lda rob
 cmp tsekw,x
 bne sk1
 lda tcont,x  ;zakonczenie animki
 sta tproc,x
 lda #0
 sta tlicz,x
 jmp anmq

sk1
; clc
; adc #1
; sta tlicz,x

 inc tlicz,x

an_ jmp anmq


;---------------------;
* Tworzenie eksplozji *
;---------------------;
explo ldx tposy,y
 lda l_adr,x
 sta pom
 lda h_adr,x
 sta pom+1

 lda #0
 sta tsprt,y
* lda tmocy,y

 sty rob
 ldy czyje,x	;moc bomby bohatera
 lda csh+9,y
 sta moc
 ldy rob

 ldx tposy,y
 stx posy
 lda #_nic	;usun bombe
 sta map,x

 ldy czyje,x	;odejmij bombe graczowi
 lda csh+10,y
 sec
 sbc #1
 sta csh+10,y

 lda #0		;nr eksplozji - srodek
 jsr pexpl

 lda moc
 sta tmp
 ldx posy
 lda #5
 sta _expl+1	;nr eksplozji
 lda #1
 sta _exp_+1	;koncowka eksplozji
up lda tSbc16,x
 tax
; lda tmp+1	;rysuj w gore wybuch
; sec
; sbc #16
; sta tmp+1
 jsr tst
 beq _rg
 dec tmp
 bne up

_rg lda moc
 sta tmp
 ldx posy
; sta tmp+1
 lda #6
 sta _expl+1
 lda #2
 sta _exp_+1
rg
; inc tmp+1	;rysuj w prawo wybuch
; ldx tmp+1
 inx
 jsr tst
 beq _dw
 dec tmp
 bne rg

_dw lda moc
 sta tmp
 ldx posy
; sta tmp+1
; sta dw+1
 lda #5
 sta _expl+1
 lda #3
 sta _exp_+1
dw lda tAdc16,x
 tax
; stx dw+1
; lda tmp+1	;rysuj w dol wybuch
; clc
; adc #16
; sta tmp+1
 jsr tst
 beq _lf
 dec tmp
 bne dw

_lf lda moc
 sta tmp
 ldx posy
; sta tmp+1
 lda #6
 sta _expl+1
 lda #4
 sta _exp_+1
lf
; dec tmp+1	; rysuj w lewo wybuch
; ldx tmp+1
 dex
 jsr tst
 beq _ex
 dec tmp
 bne lf
 
_ex ldx #0	; odegraj efekt wybuchu
 jsr add_sfx
 jmp anmq

;--------------;
* Wybuch murku *
;--------------;
pexm1 jsr gpos
 txa
 sta tposy,y

 lda #_mur2 ;zeby inny wybuch
 sta map,x  ;nie niszczyl jeszcze raz

 lda #0
 sta tlicz,y
 lda #6
 sta tdela,y
 lda #4
 sta tsekw,y

 lda <exm1a
 sta l_anm,y
 lda >exm1a
 sta h_anm,y

 lda #_sta
 sta tproc,y
 lda #_cm1
 sta tcont,y

 lda #$80
 sta tsprt,y
 sta tcloc,y
 lda #0
 rts

;---------------;
* Testuj wybuch *
;---------------;
tst lda death,x	; czy to pole pali sie
 and #1
 bne tq
 
 lda map,x

 cmp #_nic
 beq _expl	; eksplozja
 
 cmp #_mur1
 beq pexm1	; eksplozja _mur1
 cmp #_bmb
 beq _exbm	; eksplozja bomby
 
; cmp #_bom	; eksplozje ikonek
; beq _exik
; cmp #_fir
; beq _exik

 cmp #_cza
 beq _exikCzacha

 and #$f0
 cmp #$50
 beq _exik

* cmp #_mur2
* beq tq
* lda #1
* rts
tq lda #0	;0 konczy szukanie
 rts

_expl lda #0
 ldy tmp	;czy koniec ognia
 dey   
 bne _e0

_exp_ lda #0
_e0 jsr pexpl
 lda #1
 rts
;_exm1 jmp pexm1
; lda #0
; rts

_exbm lda death,x
 ora #1
 sta death,x
 lda #0
 rts

_exik lda #0
 sta bonus,x
* procka do wybuchu ikonki
; jmp eiko
; lda #0
; rts

;------------------;
* Eksplozja ikonki *
;------------------;
eiko jsr gpos
 txa
 sta tposy,y

 lda #0
 sta tlicz,y
 lda #6
 sta tdela,y
 lda #7
 sta tsekw,y

 lda <exiko
 sta l_anm,y
 lda >exiko
 sta h_anm,y

 lda #_sta
 sta tproc,y
 lda #_clr
 sta tcont,y

 lda #$80
 sta tsprt,y
 sta tcloc,y
 lda #0
 rts

;-------------------------;
* Eksplozja ikonki Czachy *
;-------------------------;
_exikCzacha lda #0
 sta bonus,x

 jsr eiko

 lda #_clB
 sta tcont,y
 lda #0
 rts

;--------------------------;
* Kasuje znacznik animacji *
;--------------------------;
;clear lda #0
; sta tsprt,y
; jmp anmq

clexp ldx tposy,y   ;eksplozji
 lda death,x
 and #$fe
 sta death,x
clear lda #0
 sta tsprt,y
 jmp anmq
; jmp clear


clearBuum sty tmpY+1
 ldy #0			;sprawdzamy ktory sprite jest wolny i go ustawiamy
 ldx #$60
 lda xcsh+22,y
 ora xcsh+23,y
 bne newSpr

 ldy #len
 ldx #$64
 lda xcsh+22,y
 ora xcsh+23,y
 bne newSpr

 ldy #len*2
 ldx #$68
 lda xcsh+22,y
 ora xcsh+23,y
 bne newSpr

 ldy #len*3
 ldx #$6c
 lda xcsh+22,y
 ora xcsh+23,y
 bne newSpr

tmpY ldy #0
 jmp clear

;---

newSpr
; sty bufY+1
 sty newS_+1
 stx bufX+1
 lda #0
 ldx #len-1
newS_ sta xcsh,x
; iny
 dex
 bpl newS_

;bufY ldy #0
bufX lda #0
 sta xcsh+1,y

 lda $d20a		;losujemy czy bedzie to gabka czy zarowka
 eor $d20a
 bpl zaroweczka
 
 lda #2
 sta xcsh+13,y
 mwa #gab xcsh+8,y
 mwa #gab_ex xcsh+27,y
 jmp endBuum

zaroweczka lda #4+1
 sta xcsh+13,y
 mwa #zar xcsh+8,y
 mwa #zar_ex xcsh+27,y

endBuum jsr iniSprVal
 ldx tmpY+1
 lda tposy,x
 sta xcsh,y

 ldy tmpY+1
 jmp clear

;---

clrm1 ldx tposy,y   ;murku
 lda l_adr,x
 sta pom
 lda h_adr,x
 sta pom+1
 sty tmp

 ldy #0
 lda #_nic          ;z mapy
 sta map,x
 sta (pom),y        ;z ekranu
 ora #1
 iny
 sta (pom),y

 ldy tmp
 lda bonus,x
 bne pikon
 lda #0
 sta tsprt,y
 jmp anmq

;-------;
* Ikona *
;-------;
pikon sta map,x
 sec
 sbc #_bom
 lsr @
 tax

 lda #0
 sta tlicz,y
 lda #11
 sta tdela,y
 lda #1
 sta tsekw,y

 lda tikon,x
 sta l_anm,y
 lda tikon+1,x
 sta h_anm,y

 lda #_st3
 sta tproc,y
; lda #_st3
 sta tcont,y

 lda #$80
 sta tsprt,y
 sta tcloc,y
 jmp anmq


;----------------------------------------------------;
* Stawianie pojedynczych eksplozji, nr eksplozji w A *
;----------------------------------------------------;
pexpl stx rob	; zapamietaj rejstr X i Y

; asl @
 tax
 jsr gpos
 
 lda ltexpa,x
 sta l_anm,y
 lda htexpa,x
 sta h_anm,y

 lda rob
 sta tposy,y
 tax

 lda death,x  ;zaznaczamy wybuch
 ora #1       ;pola smierci
 sta death,x

 lda #0
 sta tlicz,y
 lda #3+1
 sta tdela,y
 lda #7
 sta tsekw,y

 lda #_sta
 sta tproc,y
 lda #_cex
 sta tcont,y

 lda #$80
 sta tsprt,y
 sta tcloc,y
 rts

;-----------;
* B O M B A *
;-----------;
pbomb jsr gpos	;postaw bombe

 lda sprt+1	;ktory gracz
 sta czyje,x

 lda #_bmb
 sta map,x
 txa
 sta tposy,y
* lda rob
* sta tmocy,y

 lda #0
 sta tlicz,y
 lda #13
 sta tdela,y
 lda #10
 sta tsekw,y
 lda <abomb
 sta l_anm,y
 lda >abomb
 sta h_anm,y

 lda #_st2
 sta tproc,y
 lda #_wyb
 sta tcont,y

 lda #$80
 sta tsprt,y
 sta tcloc,y
 
 ldx #1
 jsr add_sfx    ; efekt tykania bomby
 rts

;---

gpos ldy #$ff   ;wolny wpis do tsprt
_g0 iny
 lda tsprt,y
 bne _g0
 
 cpy maxAnm+1	;ustalenie nowego zakresu przeszukiwania tablicy
 bcs newMax
 rts
newMax iny
 sty maxAnm+1
 dey
 rts
 
;-----------;
* Map Clear *
;-----------;
mapClr ldy #0
nx00 lda mapBuf,y
 cmp #_mur2
 beq nx01
 cmp #_black
 beq nx01
 lda #_nic
 sta map,y
 
nx01 iny
 cpy #wy_scr*sz_scr
 bne nx00
 
 ldy #0
 tya
 sta bonus,y
 iny
 bne *-4 
 rts

;------------;
* MAP -> SCR *
;------------;
map2scr mwa #map hlp
 mwa #scr pom
 
 ldx #wy_scr
pp ldy #0
 lda (hlp),y
 pha

 tya
 asl @
 tay

 pla
 sta (pom),y
 ora #1
 iny
 sta (pom),y

 inc pp+1
 lda pp+1
 cmp #sz_scr
 bne pp
 
 jsr add_pom

 lda hlp
 clc
 adc #sz_scr
 sta hlp
 bcc *+4
 inc hlp+1

 lda #0
 sta pp+1
 dex
 bne pp
 rts

add_pom
 lda pom
 clc
 adc #32
 sta pom
 bcc *+4
 inc pom+1
 rts

;----------------------------------------------;
* losuje polozenie murku, bomb, ognia, czaszek *
;----------------------------------------------;
losmur ldx #0
 ldy #0
 sty ilbom+1
 sty ilfir+1
 sty ilcza+1
 
ww lda map,y
 cmp #_mur2
 beq sww

 sta $d40a
 lda $d20a	;bonus bomba
 cmp #36
 bcs ls00
ilbom lda #0
 cmp #10
 beq ls00
 inc ilbom+1
 lda #_bom
 sta bonus,y

ls00 sta $d40a
 lda $d20a	;bonus ogien
 cmp #22
 bcs czacha
ilfir lda #0
 cmp #10
 beq czacha
 inc ilfir+1
 lda #_fir
 sta bonus,y

czacha lda #1	;tryb On/Off
 beq no_cz

 lda $d20a	;bonus czacha
 cmp #27
 bcs no_cz
ilcza lda #0
 cmp #10
 beq no_cz
 inc ilcza+1
 lda #_cza
 sta bonus,y

no_cz sta $d40a
 lda $d20a	;losuj mur
 cmp #192	;powyzej wartosci
 bcs sww
 lda #_mur1
 sta map,y

sww iny
 inx
 cpx #sz_scr-1
 bne ww

 ldx #0
 iny
 bne ww

 lda #_nic  ;narozniki puste
 sta map+17
 sta map+18
 sta map+33

 sta map+28
 sta map+29
 sta map+45

 sta map+193-32
 sta map+209-32
 sta map+210-32

 sta map+205-32
 sta map+221-32
 sta map+220-32
 rts
 
 
twardyMur lda #_mur2
 ldy #0
twar sta map+32+2,y
 iny
 iny
 cpy #12
 bne twar
 rts

;-----;
* NMI *
;-----;
nmi bit $d40f
 bpl vbl

vdli jmp dli

vbl sta rA02+1
 stx rX00+1
 sty rY00+1
 sta $d40f

 lda $d00c
 cmp #3
 bcc vb__
 sta kolizja+1

vb__ inc time

_560 lda #0
 sta $d402
_561 lda #0
 sta $d403
_559 lda #0
 sta $d400
 lda >fnt2
 sta $d409
 lda >fnt
 sta f_+1
 lda #$04
 sta $d01b

; lda m00	; kolory panelu
; sta $d012
; lda m01
; sta $d014
; lda h00_
; sta $d013
; lda h01_
; sta $d015

 lda _708
 sta $d016
 lda _709
 sta $d017
 lda _710
 sta $d018
 lda _711
 sta $d019
 lda #0
 sta $d01a

; lda #$74
 lda pmCol
 sta Player1_Missile1_Color1_PM1
; lda #$28
 lda pmCol+1
 sta Player0_Missile0_Color0_PM0
; lda #$88
 lda pmCol+2
 sta Player2_Missile2_Color2_PM2
; lda #$F8
 lda pmCol+3
 sta Player3_Missile3_Color3_PM3

 lda #$9E
 sta Player1_PositionX
 sta Player2_PositionX
 lda #$51
 sta Player0_PositionX
 lda #$86
 sta Player3_PositionX

 mwa #dli vdli+1

;---------------------------------;
* wywolywanie efektow dzwiekowych *
;---------------------------------;
 lda tab_sfx
 beq _sfx1
 
 lda limit_sfx
 sta lim+1
 lda adres_sfx
 ldy index_sfx
 ldx #0			; kanal #0 i #1, POKEY #1
 jsr play_sfx
 sty index_sfx
 sty tab_sfx

_sfx1 lda tab_sfx+1
 beq _sfx2

 lda limit_sfx+1
 sta lim+1
 lda adres_sfx+1
 ldy index_sfx+1
 ldx #2 		; kanal #2 i #3, POKEY #1
 jsr play_sfx
 sty index_sfx+1
 sty tab_sfx+1

_sfx2 lda tab_sfx+2
 beq _sfx3

 lda limit_sfx+2
 sta lim+1
 lda adres_sfx+2
 ldy index_sfx+2
 ldx #$10 		; kanal #0 i #1, POKEY #2
 jsr play_sfx
 sty index_sfx+2
 sty tab_sfx+2

_sfx3 lda tab_sfx+3
 beq _Key_test

 lda limit_sfx+3
 sta lim+1
 lda adres_sfx+3
 ldy index_sfx+3
 ldx #$12		; kanal #2 i #3, POKEY #2
 jsr play_sfx
 sty index_sfx+3
 sty tab_sfx+3

_Key_test
 lda $d20f
 ora #0
_last_key equ *-1
 and #4
 bne clock
 
 ldx $d209
 cpx #0
_old_key equ *-1
 bne _new_key

_inc_delay
 inc delay
 lda #0
delay equ *-1
 cmp #6
 bne clock

_new_key
 cpx #$21
 bne _esc_
 
 stx _old_key
 lda stop_hero+1
 bne _pause

 lda #0 
 sta stop+1
 sta clock+1
 sta delay
 lda #$ff
 sta stop_hero+1	;pozwol przenosic pozycje X graczy na ekran
 lda #128
 sta over
 mwa #koniec jmpKon+1 
 jmp clock

_pause
 lda #$ff       	;zatrzymanie enginu gry i czasu
 sta stop+1
 sta clock+1
 lda #0
 sta stop_hero+1
 sta delay
 mwa #_null_Loop jmpKon+1 
 jmp clock
 
_esc_
 cpx #$1c
 bne clock
 
 lda stop_hero+1
 beq clock
 
 stx _old_key
 lda #0
 sta rundA+1
 sta rundB+1
 sta delay
 lda #$ff
 sta _last_key
 jmp all_death
 
;-------;
* CLOCK *
;-------;
_ek equ bar+32

clock lda #0
 bne rA02
 lda time
 cmp #50
 bne rA02
 and #0
 sta time

;  jmp rA02

 dec _s
 bne _czas
 lda #59
 sta _s

 dec _m
 lda _m		;czy koniec czasu?
 cmp #$ff	;w _m minuty
 bne _czas

all_death
 sta clock+1
 lda #$ad	;modyfikacja adresu na "lda tabBar"
 sta MassKill
 mwa #LCyfra MassKill+1

; ldy #0
; sta death,y    ;koniec czasu, smierc dla wszystkich
; iny
; bne *-4

 lda #0
 sta _s
 sta _m

_czas ldy _s
 ldx Lcyfra,y
 lda Pcyfra,y
 stx _ek+10
 sta _ek+11

 ldy _m
 lda Pcyfra,y
 sta _ek+8

rA02 lda #0
rX00 ldx #0
rY00 ldy #0
 rti

;---

nmi_null mwa #nulNMI $fffa
 lda #$40
 sta $d40e
 rts

nulNMI pha
 sta $d40f
 inc time
; mwa #nulAnt $d402
 lda #0
 sta $d000
 sta $d001
 sta $d002
 sta $d003
 sta $d400
 pla
 rti

;---

iniZeroPage
 ldy #0
 tya
ii sta $00,y
 iny
 bne ii
 
 ldy #$7f
inZ lda subZer00_,y
 sta subZer00,y
 dey
 bpl inZ
 rts

;-------------------------;
* odgrywa efekt dzwiekowy *
;-------------------------;
play_SFX sta hsfx+2
 sta hsfx_+2
 
hsfx	lda $ff00,y
	sta $d200,x
hsfx_	lda $ff80,y
	sta $d201,x
 iny
lim cpy #0
 bne sfx_q
 ldy #0
sfx_q rts

;---

move stx src+2
 sty dst+2
 tax
 ldy #0
src lda $ff00,y
dst sta $ff00,y
 iny
 bne src
 inc src+2
 inc dst+2
 dex
 bne src
 
 sty src+1
 sty dst+1
 rts

;------------------------------;
* DLI w obrebie strony pamieci *
;------------------------------;
dli sta ra_+1

 lda pmCol+4
 sta Player0_Missile0_Color0_PM0 

 lda <dli1_
 sta vdli+1
ra_ lda #0
 rti


dli1_ sta rA00+1
 lda >fnt
 sta $d40a
 sta $d409

 lda k708		; kolory pola gry
 sta $d016
 lda k709
 sta $d017
 lda k710
 sta $d018
 lda k711
 sta $d019
 lda #%00100001
 sta $d01b		;piorytety
 
 lda csh+23		;przepisywanie pozycji X graczy z tablic do rejestrow
Stop_hero and #0
 sta $d000
 sta $d001
 lda csh+23+siz
 and Stop_hero+1
 sta $d002
 sta $d003

 lda csh+21             ;kolor graczy na polu gry, mruga gdy wzial czaszke
 sta $d012
 lda csh+21+siz
 sta $d014
 
 lda h00_
 sta $d013
 lda h01_
 sta $d015
 
 lda <dli2
 sta vdli+1
rA00 lda #0
 rti

dli2 sta rA01+1
f_ lda >fnt
 sta $d40a
 eor #4
 sta f_+1
 sta $d409
rA01 lda #0
 rti

;---

init lda >tproc  ;czysc tablice
 sta cl+2
 ldx #$1c
 ldy #0
 tya
cl sta $ff00,y
 iny
 bne cl
 inc cl+2
 dex
 bne cl
 
 ldy #0
tb tya
 lsr @
 lsr @
 asl @
 asl @
 asl @
 asl @
 sta tabY,y
 
 tya
 lsr @
 lsr @
 and #$f
 sta tabX,y
; iny
; bne tb
 
; ldy #0
 ldx #1
 jsr losuj
 sta tAruch,y
 ldx #2
 jsr losuj
 sta tAruch+$100,y
 ldx #3
 jsr losuj
 sta tAruch+$200,y
; iny
; bne tl
 
; ldy #0		;tablice dla wybuchu ognia
 tya
 sub #16
 sta tSbc16,y
 tya
 add #16
 sta tAdc16,y
 
 lda #0
 sta marker,y
 iny
 bne tb
 
 ldx >l_adr
 lda <scr
 ldy >scr

calc stx d0+2
 inx
 stx d1+2
 sta c0+1
 sty c1+1
 ldx #0
adresZnk lda #0
 sta hlp+1        ;adres znaku
 txa
 asl @
 rol hlp+1
 clc
c0 adc <scr
d0 sta $ff00,x
 lda hlp+1
c1 adc >scr
d1 sta $ff00,x
 inx
 bne adresZnk
 rts
 
losuj lda #0
 sta bak
 nop
los_ lda $d20a
 and #1
 add bak
 sta bak
 dex
 bne los_
 rts
 
;----------------;
* Init Dyna Hero *
;----------------;
iniHero
 lda #0
 sta $d01e	;skasowanie rejestru kolizji
 
 ldy #17	;zerujemy ustawienia kazdego gracza
nl_ lda nul,y
 sta csh+8,y
 sta csh+8+siz,y
 dey
 bpl nl_

 lda czacha+1
 beq skp__

PolePosition lda #0
 and #3
 asl @
 asl @
skp__ tay
 lda PolPos,y
 sta csh+4
 lda PolPos+1,y
 sta csh+5
 lda PolPos+2,y
 sta csh+4+siz
 lda PolPos+3,y
 sta csh+5+siz
 
 inc PolePosition+1

 lda #colPlay1		;kolory
* sta $2c0	;bohater 1
 sta csh+22
 sta csh+21
; lda #colPlay1+6
; sta $d013

 lda #colPlay2		$84	;bohater 2
* sta $2c2
 sta csh+22+siz
 sta csh+21+siz
; lda #colPlay2+$14	$98
; sta $d015

 ldy #0
 sty hlp
 sty hlp+1
i0 tya
 asl @
 tax
 lda hlp
 sta tadd,x
 lda hlp+1
 sta tadd+1,x

 lda hlp
 clc
 adc #30	;wysokosc max sprita
 sta hlp
 bcc *+4
 inc hlp+1
 iny
 cpy #20
 bne i0
 
 lda #0
 sta dyna+1
 sta faza+1
 sta anm+1
 
 tay
 jsr test	;ustawiamy bohaterow
 jsr faza
 jsr sprt
 jsr dyna

 ldy #siz
 jsr test
 jsr faza
 jsr sprt
 jsr dyna
 
 lda #0		;czas rozgrywki 3min
 sta time
 ldy #2
 sty _m
 lda Pcyfra,y
 sta _ek+8
 
 ldy #59
 sty _s
 ldx Lcyfra,y
 lda Pcyfra,y
 stx _ek+10
 sta _ek+11

 jsr rundA	;ile rund ma trwac rozgrywka
 rts
 
;---

rundA ldy #0
 lda Pcyfra,y
 sta bar+53
rundB ldy #0
 lda Pcyfra,y
 sta bar+59
 rts

;---

ClrSprt

 lda >pm
 sta $d407	;adres spritow
; lda #%00100001
; sta $d01b	;piorytety
 lda #3		;bit 1 dla graczy
 sta $d01d	;bit 0 dla pociskow

 ldy #$c
 lda #0
i_ sta $d000,y
 dey
 bpl i_

 tay
l sta tsprt,y
 sta pm+$400,y  ;sprite 0
 sta pm+$500,y  ;sprite 1
 sta pm+$600,y  ;sprite 2
 sta pm+$700,y  ;sprite 3
 sta death,y
 sta xcsh,y	;czyszczenie tablic XCSH
 iny
 bne l

 ldy #20	; pokaz mordki
jjj lda tabBar,y
 sta pm+$400+11,y
 lda tabBar+21*1,y
 sta pm+$500+11,y
 lda tabBar+21*2,y
 sta pm+$600+11,y
 lda tabBar+21*3,y
 sta pm+$700+11,y
 dey
 bpl jjj
 rts

;----------------------------------------;
* dodaje nowy efekt dzwiekowy do kolejki *
;----------------------------------------;
* X=0 to wybuch
* X=1 to polozenie bomby
* X=2 to zebranie ikonki

add_sfx ldy #0
 lda tab_sfx,y
 beq add_ok
 iny
 lda tab_sfx,y
 beq add_ok 
 iny
 lda tab_sfx,y
 beq add_ok 
 iny
 lda tab_sfx,y
 beq add_ok 
 rts			; nic nie znalazl, widocznie aktualnie cos odgrywa

add_ok			; znalazl wolne miejsce w 4bajtowej tablicy
 lda lim_sfx,x
 sta limit_sfx,y
 lda idx_sfx,x
 sta index_sfx,y
 
 lda adr_sfx,x
 sta adres_sfx,y
 sta tab_sfx,y
 rts

;-----------;
* Dyna hero *
;-----------;
sprt ldy #0   ;zapamietaj
 lda old+1
 sta csh,y
 lda del+1
 sta csh+1,y
 lda dyna+1
 sta csh+2,y
 lda faza+1
 sta csh+3,y
 lda x
 sta csh+4,y
 lda y
 sta csh+5,y
 lda mbmb
 sta csh+8,y
 lda moc
 sta csh+9,y
 lda ibmb
 sta csh+10,y
 lda hits
 sta csh+11,y
 lda repe+1
 sta csh+12,y
 lda skul
 sta csh+13,y
 lda sra+1
 sta csh+18,y
 lda del_+1
 sta csh+19,y
 lda old_+1
 sta csh+20,y
 rts

test sty sprt+1  ;zdejm
 lda csh,y
 sta old+1
 lda csh+1,y
 sta del+1
 lda csh+2,y
 sta dyna+1
 lda csh+3,y
 sta faza+1
 lda csh+4,y
 sta x
 lda csh+5,y
 sta y
; ldx csh+6,y
; stx _sx0+1
; inx
; stx _sx1+1
 ldx csh+7,y
 stx _s0+2
 inx
 stx _s1+2
 lda csh+8,y
 sta mbmb
 lda csh+9,y
 sta moc
 lda csh+10,y
 sta ibmb
 lda csh+12,y
 sta repe+1
 lda csh+18,y
 sta sra+1
 lda csh+19,y
 sta del_+1
 lda csh+20,y
 sta old_+1

 lda csh+13,y
 sta skul       ;czy czacha
 beq sp0

;---

 lda csh+21,y   ;dzialanie czachy, mruganie kolorem gracza
 eor #4
 sta csh+21,y
 
 lda csh+14,y   ;zlicz czas dzialania czachy
 clc
 adc #1
 sta csh+14,y
 lda csh+15,y
 adc #0
 sta csh+15,y

; lda csh+15,y		;czas przez jaki dziala czacha
 cmp #2
 bne sp0
 
 jsr old_val

sp0 lda csh+11,y	;detekcja smierci
 sta hits
 bne hi

 jsr cntr               ; CNTR zmienia rejestr X,Y

MassKill lda death,x	;czy trafiony od ognia
 beq joy
 sta hits
 
 lda skul	;jesli oberwal i dzialala czacha to wylacz czache
 beq _m0
 
 ldy sprt+1
 jsr old_val

_m0 lda #0
; ldy sprt+1
 sta mbmb	;delay  /8
 sta repe+1	;czy pokazywac  /10
 lda #2
 sta del+1
 lda #wyb
 sta ibmb	;faza  /9

 ldx #3
 jsr add_sfx

hi lda repe+1
 bne hiq

 inc mbmb
 lda mbmb
 cmp #9		;co 9 ramek, wybuch bohatera
 bne hiq
 lda #0
 sta mbmb

 lda ibmb
 jsr faza
 jsr dyna

 inc ibmb
 lda ibmb
 cmp #wyb+5	;5 klatek animacji
 bne hiq
 lda #$ff	;nie obsluguj gracza
 sta repe+1
hiq jmp sprt

;---

nic lda #0      ;pierwsza faza gdy nic
 sta dyna+1
 jsr dyna
sprt_ jmp sprt

;---

joy equ *
sra lda #0
 beq _m1
 jmp pbmb

_m1 lda $d010	;trig0
 ldy sprt+1
 beq _m2
 lda $d011	;trig1
_m2 tay

old_ cmp #2	;repetycja trig
 beq del_
 sta old_+1
jc_ lda #12
 sta del_+1

 tya
 cmp #0
 bne jc
 jmp pbmb

jc lda $d300
 ldy sprt+1
 beq j0
 :4 lsr @
j0 and #$0f
 tay

old cmp #0  ;repetycja joya
 beq del
 sta old+1
repe lda #0
 sta del+1
 jmp joyc

del_ lda #0
 dec del_+1
 bne jc
 jmp jc_

del lda #0   ;repetycja
 dec del+1
 bne sprt_
 lda repe+1
 sta del+1
 
joyc lda ljmp,y		; dlugi skok, wg tablicy ljmp, hjmp
 beq nic
 sta joy_jmp+1
joy_jmp jmp p_uplf
 
; cmp #14
; beq _up_
; cmp #13
; beq _dw_
; cmp #7
; beq _rg_
; cmp #11
; beq _lf_

; cmp #10
; beq p_uplf
; cmp #9
; beq p_dwlf
; cmp #6
; beq p_uprg
; cmp #5
; beq p_dwrg

p_uplf jsr gadr
 lda map-16,x
 jsr tstom
 beq _up_
 jmp _lf_

p_uprg jsr gadr
 lda map-16,x
 jsr tstom
 beq _up_
 jmp _rg_

p_dwlf jsr gadr
 lda map+16,x
 jsr tstom
 beq _dw_
 jmp _lf_

p_dwrg jsr gadr
 lda map+16,x
 jsr tstom
 beq _dw_
 jmp _rg_

;---

u_rgc jsr gadr  ;omijaj jesli puste
 lda map+1-16,x
 jsr tstom
 bne _upq
 jmp _rgc
u_lfc jsr gadr
 lda map-16,x
 jsr tstom
 bne _upq
 jmp _lfc

d_lfc jsr gadr
 lda map+16,x
 jsr tstom
 bne _upq
 jmp _lfc
d_rgc jsr gadr
 lda map+1+16,x
 jsr tstom
 bne _upq
 jmp _rgc

_up_ lda #gor
 jsr faza
 lda x
 and #3
 beq _upm
 lda x
 and #4
 bne u_rgc
 jmp u_lfc
_upm lda y
 and #3
 bne _upc
 jsr gadr
 ldy #$f0
 lda map-16,x
* cmp #_nic
 jsr tstru
 bne _upq
_upc dec y
_upq jsr dyna
 jmp joy

_dw_ lda #dol
 jsr faza
 lda x
 and #3
 beq _dwm
 lda x
 and #4
 beq d_lfc
 jmp d_rgc
_dwm lda y
 and #3
 bne _dwc
 jsr gadr
 ldy #16
 lda map+16,x
* cmp #_nic
 jsr tstru
 bne _dwq
_dwc inc y
_dwq jsr dyna
 jmp joy

_rg_ lda #pra
 jsr faza
 lda y      ;test kolizji z murem
 and #3
 beq _rgm
 lda y
 and #4     ;slizg wokol muru
 beq r_upc
 jmp r_dwc
_rgm lda x
 and #3
 bne _rgc
 jsr gadr
 ldy #1
 lda map+1,x
* cmp #_nic
 jsr tstru
 bne _rgq
_rgc inc x
_rgq jsr dyna
 jmp joy

_lf_ lda #lew
 jsr faza
 lda y
 and #3
 beq _lfm
 lda y
 and #4
 beq l_upc
 jmp l_dwc
_lfm lda x
 and #3
 bne _lfc
 jsr gadr
 ldy #$100-1
 lda map-1,x
* cmp #_nic
 jsr tstru
 bne _lfq
_lfc dec x
_lfq jsr dyna
 jmp joy

r_dwc jsr gadr
 lda map+17,x
 jsr tstom
 bne _lfq
 jmp _dwc
r_upc jsr gadr
 lda map+1,x
 jsr tstom
 bne _lfq
 jmp _upc

l_upc jsr gadr
 lda map-1,x
 jsr tstom
 bne _lfq
 jmp _upc
l_dwc jsr gadr
 lda map-1+16,x
 jsr tstom
 bne _lfq
 jmp _dwc

tstom cmp #_nic
 beq _0
 and #$f0
 cmp #$50
 bne _1
; cmp #_bom  ;test dla mijania
; beq _0
; cmp #_fir
; beq _0
; cmp #_cza
; beq _0
; cmp #_nic
; bne _1
_0 lda #0
 rts
_1 lda #1
 rts

tstru sty tmp
 sta tmp+1
 jsr gadr
; txa
 clc
 adc tmp
 tax

 lda tmp+1
 cmp #_nic
 beq _0
 cmp #_cza
 beq gcza
 cmp #_bom      ; test dla ruchu
 beq gbmb
 cmp #_fir
 beq gfir
_xx lda #1
 rts


gbmb lda #0	; wez bombe
 sta bonus,x

 ldx #2         ; dzwiek zebranej ikonki
 jsr add_sfx

 lda skul	; jesli  dziala czaszka to zwieksz zapasowe wartosci
 beq gbmbQ
; ldy sprt+1
; lda csh+16,y
; clc
; adc #1
; sta csh+16,y

 ldx sprt+1
 inc csh+16,x
 lda #0
 rts
gbmbQ inc mbmb
 lda #0
 rts

 
gfir lda #0     ; wez moc
 sta bonus,x

 ldx #2         ; dzwiek zebranej ikonki
 jsr add_sfx

 lda skul
 beq gfirQ
; ldy sprt+1
; lda csh+17,y
; clc
; adc #1
; sta csh+17,y

 ldx sprt+1
 inc csh+17,x
 lda #0
 rts
gfirQ inc moc
 lda #0
 rts

;---
 
gcza lda #0	; wez czache
 sta bonus,x

 ldy sprt+1

 lda skul
 beq cza_
 jsr old_val
 
cza_ lda #1
 sta skul
 lda mbmb
 sta csh+16,y
 lda moc
 sta csh+17,y

 ldx #2         ; dzwiek zebranej ikonki
 jsr add_sfx

 clc
 ldy $d20a      ; losuj czaszki
 lda tAruch+512,y
 ldy $d20a
 adc tAruch+512,y
 tay
 
 lda tjump,y	; modyfikacja skoku, ktory nie moze przekroczyc strony pamieci
 sta _jump+1
_jump jmp _nul

; beq _slw
; cmp #1
; beq _fst
; cmp #4
; beq _fmn
; cmp #3
; beq _fzr
; cmp #2
; beq _sra
; cmp #5
; beq _max

_nul lda #0	; nic nie wylosowal
 sta skul
 rts

_max lda #15	; zwieksza moc bomby
 sta moc
 lda #0
 rts

_sra lda #1	;sra bomby
 sta sra+1
 lda #0
 rts

_fst lda #2	;szybciej
 bne *+4
_slw lda #8	;wolniej
 sta repe+1
 lda #0
 rts

_fzr lda #0	;bez bomb
 sta mbmb
 rts
 
_fmn lda #1	;tylko jedna bomba o malej mocy
 sta mbmb
 sta moc
 lda #0
 rts

;---

lim_sfx dta b(48,16,64,127)	; dlugosc efektu
adr_sfx dta h(bum,tik,tik,bum)	; starszy bajt adresu efektu
tab_sfx dta b(0,0,0,0)		; jesli =0 to brak efektu,  jesli <>0 to graj efekt
idx_sfx dta b(0,0,16,48) 	; poczatkowa wartosc indexu

limit_sfx dta b(0,0,0,0)	; dlugosc efektu
adres_sfx dta b(0,0,0,0)	; starszy bajt adresu efektu
index_sfx dta b(0,0,0,0)	; aktualna wartosc indexu

;---

old_val lda #0		;old values
 sta skul
 sta csh+14,y
 sta csh+15,y
 sta sra+1
 lda #4
 sta repe+1
 lda csh+16,y
 sta mbmb
 lda csh+17,y
 sta moc
 lda csh+22,y
 sta csh+21,y
 rts

;---

faza cmp #0	;test fazy
 beq fazaQ
 sta faza+1
 lda #0
 sta dyna+1	;pierwsza klatka
fazaQ rts	;danej fazy

pbmb jsr cntr
 lda map,x    ;jesli cos
 cmp #_nic
 bne pbq
 lda death,x  ;jesli ogien
 and #1
 bne pbq

 lda mbmb
 beq pbq
 cmp ibmb
 beq pbq

 inc ibmb  ;liczba bomb postawionych

* lda moc
 jsr pbomb
pbq jmp jc

;---

dyna ldx #0
 lda tkol,x
 clc
 adc faza+1
 asl @
 tay

 lda tadd,y
 clc
 adc <buf0
 sta a0+1
 sta a1+1
 lda tadd+1,y
 adc >buf0
 sta a0+2
 adc >buf1-buf0
 sta a1+2

 inx
; inc dyna+1
; lda dyna+1
 cpx #12
 bne _d0
 ldx #0
; sta dyna+1

_d0 stx dyna+1

 lda y
 asl @
 asl @
 clc
 adc #48-3         ;ofset Y
; tay
 sta _s0+1
 sta _s1+1
 
 ldx sprt+1
 sta csh+24,x

 lda x
 asl @
 clc
 adc #76
 sta csh+23,x
;_sx0 sta $d000
;_sx1 sta $d001

 ldx #29
a0 lda buf0,x
_s0 sta pm+$400,x
a1 lda buf1,x
_s1 sta pm+$500,x
 dex
 bpl a0

 rts 

;---

cntr ldx x  ;centrowanie
; stx rX+1
 ldy y
; sty rY+1

 inx
 iny
 lda faza+1
 cmp #dol
 bne cntr_s
 iny

cntr_s cmp #pra
 bne cntr_s_
 inx

; stx x
; sty y

cntr_s_
; jsr gadr_

 lda tabX,x	; powielona procedurka 'gadr_'
 ora tabY,y
 clc
 adc #17
 tax

;rX lda #0
; sta x
;rY lda #0
; sta y
 rts


gadr ldx x
 ldy y
gadr_ lda tabX,x
 ora tabY,y
 clc
 adc #17
 tax
 rts

;------------;
* koniec gry *
;------------;

koniec lda $d40b
 cmp #116
 bne koniec

; lda #10
; sta $d01a

 ldy #len*3
 jsr oddaj
 ldy #len*2
 jsr oddaj
 ldy #len
 jsr oddaj
 ldy #0
 jsr oddaj
 
;----------;
* ANM_ROUT *
;----------;
; wchodzi na ekran w nastepnej ramce
; bo zegar jest ustawiony na $80
;---
anm lda tsprt	;glowna rozdzielnia
 beq anmq

 ldy anm+1
 ldx tproc,y
 
 lda lproc,x
 sta hlp
 lda hproc,x
 sta hlp+1
 jmp (hlp)

anmq inc anm+1
 lda anm+1
maxAnm cmp #1
 bne anm
 lda #0
 sta anm+1
 
 ldy #0
 jsr shape
 ldy #len
 jsr shape
 ldy #len*2
 jsr shape
 ldy #len*3
 jsr shape

; lda #0
; sta $d01a

stop lda #0
 bne kon 
 ldy #0		; joy0
 jsr test
 ldy #siz	; joy1
 jsr test
 
 ldy #0
 jsr detect
 ldy #len
 jsr detect
 ldy #len*2
 jsr detect
 ldy #len*3
 jsr detect

 jsr kolizja		;test kolizji gracz-gracz z czacha

 lda time		;sprawdz nowe maximum dla TSPRT w ANM co pewien czas
 and #$7f
 bne kon 
 ldy maxAnm+1
; cpy #8
; bcc kon
tstMax lda tsprt,y
 bne _newMax
 dey
 bne tstMax
 ldy #0
_newMax iny
 sty maxAnm+1
 
kon lda csh+11	;pierwszy bohater, czy oberwal
 ora csh+11+siz
; cmp #$ff
; beq stp
 bne halt
 
jmpKon jmp koniec

_null_Loop jsr wai
 jmp jmpKon

halt dec over	;dajemy czas na pozostale eksplozje i testujemy kto przezyl
 bne jmpKon
 
; 	jmp retry
 	
;--- sprawdzamy kto wygral, czyli kto przezyl

 lda csh+11
 beq winB
 
 lda csh+11+siz
 beq winA

 jsr wygas	;remis, obydwaj oberwali
; dec rundA+1
; dec rundB+1

 lda rundA+1
 ora rundB+1
 beq remis_

 lda <jingle
 ldx >jingle
 jsr msxDepack
 
 lda #2
 jsr iniMsx

 lda <remisPck
 ldx >remisPck
 jsr rozpakuj
 
 lda #$4c
 sta player+3
 jsr remisPrg
 jsr powrot
 jmp nxtRund

winA dec rundA+1
 jsr wygas
 lda ile_rund+1
 sec
 sbc rundA+1
 tax
 ldy #1
 lda ile_rund+1
 jsr PokazPuchar
 jmp nxtRund 

winB dec rundB+1
 jsr wygas
 lda ile_rund+1
 sec
 sbc rundB+1
 tax
 ldy #0
 lda ile_rund+1
 jsr PokazPuchar

nxtRund
; lda rundA+1
; ora rundB+1
; beq remis_
 
 lda rundA+1
 beq winB_
 
 lda rundB+1
 beq winA_

;---

 lda #$bd	; modyfikacja adresu na "lda death,x"
 sta MassKill
 mwa #death MassKill+1

 jmp retry

;---

remis_ jmp menu

winA_ lda #0
 jmp gov
 
winB_ lda #1

;------;
* WINN *
;------;
gOv sta status+1

; jsr wygas
 
;-- pokazanie pucharu wywolalo juz rozpakowanie msx jingle
 
 lda >$d800	; zmodyfikuj starszy bajt adresu docelowego miejsca
 sta adr_out+1
 lda <winnPck	; rozpakujemy ostatni ekran
 ldx >winnPck
 jsr rozpakuj

 lda >Proc	; rozpakuj fonty pod $0800 (PROC)
 sta adr_out+1
 lda <tablPck	; rozpakujemy zestawy znakow
 ldx >tablPck
 jsr rozpakuj

; lda >Proc	; zwroc starszy bajt adresu docelowego miejsca
; sta adr_out+1
 
 lda #8
 jsr iniMsx
 lda #$4c
 sta player+3

status lda #0
 jsr winnPrg	; odpalamy ostatni ekran
 jsr powrot
; jsr nmi_null
 
 jmp menu	; i od poczatku

;---

;exi lda #$ff
; sta $d301
; lda #$40
; sta $d40e
; cli
; ldx mbmb
; ldy ibmb
; jmp error
; rts

;error sei
; lda #0
; sta $d40e
;lll lda $d20a
; sta $d01a
; jmp lll

;---

PokazPuchar sta tmA+1
 stx tmX+1
 sty tmY+1

 lda <jingle
 ldx >jingle
 jsr msxDepack
 
 lda #0
 jsr iniMsx

 lda <roundPck
 ldx >roundPck
 jsr rozpakuj

 jsr copy_bufor2proc

 jsr wai
; mwa #nulNmi $fffa
; :3 jsr wai

 lda #$4c
 sta player+3
 
tmA lda #0
tmX ldx #0
tmY ldy #0
 jsr roundPrg

 jsr powrot     ; zanim pokaze ekran, ja zdaze zamienic go na czarny
 jsr czarno
 
 jmp copy_proc2bufor
 
powrot mwa #nmi $fffa
 lda #%00111101
 sta _559+1
 lda #$c0
 sta $d40e
 jmp msxStop
 

;----------;
* fade out *
;----------;
wygas ldy #15
petelka jsr wai

 ldx #18
pl lda k708,x
 and #$0f
 beq p_0
 dec k708,x
 bne pQ
p_0 sta k708,x
pQ dex
 bpl pl
 
 lda h00
 sta csh+21
 lda h01
 sta csh+21+siz
 
 dey
 bpl petelka

czarno
 lda #0
; sta csh+23
; sta csh+23+siz
 sta stop_hero+1
 sta _559+1
 sta $d400
 jsr wai
 rts

;-------------------------------------------;
* Detekcja kolizji ze spritami programowymi *
;-------------------------------------------;
detQ rts
detect sty shp

 lda xcsh+22,y		;jesli przeszkadzajka oberwala to olac ja
 bne detQ
 lda xcsh+25,y
 sta bak+1

 lda xcsh,y
 sta bak
 and #$f
 :3 asl @
 add #67		; +2 cykle dla CLC
 ldx xcsh+26,y
 beq *+4
 adc #4

 ldx xcsh+2,y
 cpx #1
 beq _Add
 cpx #$ff
 beq _Sub
 adc #1
 bne det00
 
_sub adc #4
 sbc bak+1
 bne det00
_Add adc bak+1

det00 sta sx

 lda bak
 and #$f0
; :4 lsr @
; :4 asl @
 add #43-3

 cpx #$f0
 beq _Upp
 cpx #$10
 beq _Dww
 jmp det02
 
_Upp adc #14
 sbc bak+1
 sbc bak+1
 bne det02
_Dww add bak+1
 adc bak+1

det02 sta sy

;-------------;
* test graczy *
;-------------;
 ldx #0			;1 gracz
 jsr testX
 ldx #siz		;2 gracz
 
testX lda csh+11,x
 beq testCnt
 rts
testCnt ldy sx		;test pozycji X
 lda #$ff
 jsr put_marker
 
 ldy csh+23,x
 lda marker+1,y
 ora marker+2,y
 ora marker+3,y
 ora marker+4,y
 ora marker+5,y
 ora marker+6,y
 beq pudloX
 
testY jsr pudloX	;test pozycji Y
 ldy sy
 lda #$ff
 jsr put_markerY
 
 lda csh+24,x
 add #10
 tay
 lda marker,y
 ora marker+1,y
 ora marker+2,y
 ora marker+3,y
 ora marker+4,y
 ora marker+5,y
 ora marker+6,y
 ora marker+7,y
 ora marker+8,y
 ora marker+9,y
 beq pudloY
  
 sta csh+11,x	;trafiony, zaznaczenie kolizji
 lda #1
 sta csh+8,x	;mbmb	delay  /8
 lda #2
 sta csh+1,x	;del+1
 lda #0
 sta csh+12,x	;repe+1	czy pokazywac  /10
 lda #wyb
 sta csh+10,x	;ibmb	faza  /9
 
 ldx #3
 jsr add_sfx

pudloY ldy sy
 lda #0
put_markerY sta marker,y
 sta marker+1,y
 sta marker+2,y
 sta marker+3,y
 sta marker+4,y
 sta marker+5,y
 sta marker+6,y
 sta marker+7,y
 sta marker+8,y
 sta marker+9,y
 rts

pudloX ldy sx
 lda #0		;czysci marker kolizji
put_marker sta marker+1,y
 sta marker+2,y
 sta marker+3,y
 sta marker+4,y
 sta marker+5,y
 sta marker+6,y
 rts

poziomo ldx sx
 lda xcsh+14,y
 beq *+3
 inx
 lda death,x
 and #1
 beq pozQ
 sta xcsh+21,y		;niech stoi
 mwa xcsh+27,y xcsh+8,y
 lda #0
 sta xcsh+12,y	;klatka
 lda #5
 sta xcsh+13,y	;max klatek
 ldx #3
 jsr add_sfx
 ldy shp
pozQ rts

pionowo ldx sx
 lda xcsh+3,y
 cmp #4
 bcc *+7
 txa
 clc
 adc #$10
 tax
 
 lda death,x
 and #1
 beq pioQ
 sta xcsh+21,y		;niech stoi

 mwa xcsh+27,y xcsh+8,y
 lda #0
 sta xcsh+12,y	;klatka
 lda #5
 sta xcsh+13,y	;max klatek
 ldx #3
 jsr add_sfx
 ldy shp
pioQ rts

;-------;
* SHAPE *
;-------;
shapeQ rts
shape sty shp
 lda xcsh+22,y		;czy obslugiwac
 bne shapeQ
 
;--
 lda xcsh,y
 sta sx
 lda xcsh+1,y
 sta char
 lda xcsh+2,y
; sta kier

;--- jaki ruch

; lda kier
 beq stp
 cmp #1
 beq r_g
 cmp #$ff
 beq l_f
 cmp #$10
 beq d_w     ;$f0 w gore

u_p mwa #tstp ttab+1	;ustaw tablice zliczajaca klatki
 mwa #tup ttap+1
 jsr pionowo
 
 lda #$d0  ;bne
; jmp j_1
 bne j_1

d_w mwa #tstp ttab+1
 mwa #tdw ttap+1
 jsr pionowo
 
 lda #$d0
j_1 sta sk_
 lda #0
 sta eo_+1
 lda #8
 sta mx_+1
 jmp poz2

r_g mwa #trg ttab+1
 jsr poziomo

 lda #$d0  ;bne
; jmp j_0
 bne j_0

l_f mwa #tlf ttab+1
 jsr poziomo

 lda #$f0  ;beq
j_0 sta sk_
 lda #1
 sta eo_+1
 lda #4
 sta mx_+1
; jmp poz
 bne poz

stp mwa #tstp ttab+1
 lda #0
 sta eo_+1
 lda #$d0
 sta sk_
 lda #4
 sta mx_+1

;----------------------------;
* generuj znak, ruch poziomy *
;----------------------------;
poz jsr adres

 ldy sx
 lda l_adr,y
 sta pom
 lda h_adr,y
 sta pom+1

 tya		;zapamietaj sx i znaki
 ldx shp	;na pozycjach sx 0..2
 sta xcsh+4,x
 ldy xcsh+14,x
 tya
 sta xcsh+15,x ;zapamietaj xcsh+14
 lda (pom),y
 sta xcsh+5,x
 iny
 lda (pom),y
 sta xcsh+6,x
 iny
 lda (pom),y
 sta xcsh+7,x

;--- kopiuje znaki do bufora

 tay           ;3 znak
 lda lfnt,y
 sta tm3_+1
 sta ba3_+1
 lda hfnt,y
 sta tm3_+2
 ora #4
 sta ba3_+2

 ldy xcsh+5,x  ;1 znak
 lda lfnt,y
 sta tm_+1
 sta ba_+1
 lda hfnt,y
 sta tm_+2
 ora #4
 sta ba_+2

 ldy xcsh+6,x  ;2 znak
 lda lfnt,y
 sta tm2_+1
 sta ba2_+1
 lda hfnt,y
 sta tm2_+2
 ora #4
 sta ba2_+2

 ldy #7
 jmp subZer01

;--- modyfikuj

modyf2 ldy char
 lda lfnt,y
 sta _tm+1
 sta _ba+1
 lda hfnt,y
 sta _tm+2
 ora #4
 sta _ba+2

 lda hlp   ;rozpiska
 sta hl+1
 sta ms+1
 clc
 adc #24
 sta hl2+1
 sta ms2+1
 lda hlp+1
 sta hl+2
 adc #0
 sta hl2+2
 ora #4
 sta ms2+2
 lda msk+1
 sta ms+2
 
 ldy #23
 jmp subZer02
 

fza lda #0
 beq _f0_

 ldy xcsh+14,x
 lda char
; ora xcsh+16,x	;czy invers?
 clc		;nie bedzie potrzebny (invers to kolor szary)
 sta (pom),y
 adc #1
 iny
 sta (pom),y
 adc #1
 iny
 sta (pom),y
; jmp licz
 bne licz

;--- gdy faza zerowa to 2 znaki pokaz

_f0_ ldy xcsh+14,x
 lda char
; ora xcsh+16,x  ;czy invers
 clc
 sta (pom),y
 adc #1
 iny
 sta (pom),y

;--- liczniki

licz ldy shp
 lda #1
 sta xcsh+20,y
 
 lda xcsh+3,y
 sta xcsh+25,y
 lda xcsh+14,y
 sta xcsh+26,y

 lda xcsh+17,y	;opoznienie klatki
 clc
 adc #1
 cmp xcsh+18,y	;max
 bne si_

 lda xcsh+12,y	;klatka
 clc
 adc #1
 cmp xcsh+13,y	;max klatek
 bne mFrm
 lda xcsh+21,y
 beq mFrm_ok
 sta xcsh+22,y	;wylacz obsluge tego sprita bo oberwal
mFrm_ok lda #0
mFrm sta xcsh+12,y
 lda #0
si_ sta xcsh+17,y

 lda xcsh+10,y	;timer
 clc
 adc #1
 cmp xcsh+11,y	;max timer
 bne sip
 
 lda xcsh+21,y
 bne liczQ 
 lda xcsh+3,y
 clc
 adc #1
mx_ cmp #4
 bne sip2

 lda xcsh+14,y ;ofset 0..1
eo_ eor #1     ;dla adresu znaku
 sta xcsh+14,y ;na ekranie
sk_ bne sp_

* lda sx
* clc
* adc kier
* sta sx
 lda #0
 sta xcsh+20,y

sp_ lda #0
sip2 sta xcsh+3,y

 lda #0
sip sta xcsh+10,y

;shp ldy #0
; lda sx
; sta xcsh,y
; lda char
; sta xcsh+1,y
; lda kier
; sta xcsh+2,y
liczQ rts

;----------------------------;
* generuj znak, ruch pionowy *
;----------------------------;
poz2 jsr adres

 ldy sx
 lda l_adr,y
 sta pom
 lda h_adr,y
 sta pom+1

 tya		;zapamietaj sx i znaki
 ldx shp	;na pozycjach sx 0..1
 sta xcsh+4,x	;32..33
 ldy #0		;zawsze 0, parzyste
* ldy xcsh+14,x
 tya
 sta xcsh+15,x ;zapamietaj xcsh+14
 lda (pom),y
 sta xcsh+5,x
 iny
 lda (pom),y
 sta xcsh+6,x
 ldy #32
 lda (pom),y
 sta xcsh+7,x
 iny
 lda (pom),y
 sta xcsh+19,x  ;4 znak zapamietaj

;--- kopiuje znaki do bufora

 ldy xcsh+5,x  ;1 znak
 lda lfnt,y
 sta tmp_+1
 sta bak_+1
 lda hfnt,y
 sta tmp_+2
 ora #4
 sta bak_+2

 ldy xcsh+6,x  ;2 znak
 lda lfnt,y
 sta tmp2_+1
 sta bak2_+1
 lda hfnt,y
 sta tmp2_+2
 ora #4
 sta bak2_+2

 ldy xcsh+7,x  ;3 znak ?
 lda lfnt,y
 sta tmp3_+1
 sta bak3_+1
 lda hfnt,y
 sta tmp3_+2
 ora #4
 sta bak3_+2

 ldy xcsh+19,x ;4 znak ?
 lda lfnt,y
 sta tmp4_+1
 sta bak4_+1
 lda hfnt,y
 sta tmp4_+2
 ora #4
 sta bak4_+2
 
 ldy #7
 jmp subZer00

;--- modyfikuj

modyf ldy char
 lda lfnt,y
 sta tmp
 sta bak
 lda hfnt,y
 sta tmp+1
 ora #4
 sta bak+1

;--- pozycja Y

 ldx shp
 ldy xcsh+3,x
ttap ldx tdw,y

;--- bufor zmien

;------;
* PROC *
;------;
 ldy #0      ;1
 lda bshp,x
 and (msk),y
 ora (hlp),y
 sta bshp,x
 iny
 lda bshp+1,x
 and (msk),y
 ora (hlp),y
 sta bshp+1,x
 iny
 lda bshp+2,x
 and (msk),y
 ora (hlp),y
 sta bshp+2,x
 iny
 lda bshp+3,x
 and (msk),y
 ora (hlp),y
 sta bshp+3,x
 iny
 lda bshp+4,x
 and (msk),y
 ora (hlp),y
 sta bshp+4,x
 iny
 lda bshp+5,x
 and (msk),y
 ora (hlp),y
 sta bshp+5,x
 iny
 lda bshp+6,x
 and (msk),y
 ora (hlp),y
 sta bshp+6,x
 iny
 lda bshp+7,x
 and (msk),y
 ora (hlp),y
 sta bshp+7,x

 ldy #8      ;2
 lda bshp+32,x
 and (msk),y
 ora (hlp),y
 sta bshp+32,x
 iny
 lda bshp+33,x
 and (msk),y
 ora (hlp),y
 sta bshp+33,x
 iny
 lda bshp+34,x
 and (msk),y
 ora (hlp),y
 sta bshp+34,x
 iny
 lda bshp+35,x
 and (msk),y
 ora (hlp),y
 sta bshp+35,x
 iny
 lda bshp+36,x
 and (msk),y
 ora (hlp),y
 sta bshp+36,x
 iny
 lda bshp+37,x
 and (msk),y
 ora (hlp),y
 sta bshp+37,x
 iny
 lda bshp+38,x
 and (msk),y
 ora (hlp),y
 sta bshp+38,x
 iny
 lda bshp+39,x
 and (msk),y
 ora (hlp),y
 sta bshp+39,x

; txa
; clc
; adc #8
; tax

 ldy #24      ;3
 lda bshp+8,x
 and (msk),y
 ora (hlp),y
 sta bshp+8,x
 iny
 lda bshp+1+8,x
 and (msk),y
 ora (hlp),y
 sta bshp+1+8,x
 iny
 lda bshp+2+8,x
 and (msk),y
 ora (hlp),y
 sta bshp+2+8,x
 iny
 lda bshp+3+8,x
 and (msk),y
 ora (hlp),y
 sta bshp+3+8,x
 iny
 lda bshp+4+8,x
 and (msk),y
 ora (hlp),y
 sta bshp+4+8,x
 iny
 lda bshp+5+8,x
 and (msk),y
 ora (hlp),y
 sta bshp+5+8,x
 iny
 lda bshp+6+8,x
 and (msk),y
 ora (hlp),y
 sta bshp+6+8,x
 iny
 lda bshp+7+8,x
 and (msk),y
 ora (hlp),y
 sta bshp+7+8,x

 ldy #32      ;4
 lda bshp+32+8,x
 and (msk),y
 ora (hlp),y
 sta bshp+32+8,x
 iny
 lda bshp+33+8,x
 and (msk),y
 ora (hlp),y
 sta bshp+33+8,x
 iny
 lda bshp+34+8,x
 and (msk),y
 ora (hlp),y
 sta bshp+34+8,x
 iny
 lda bshp+35+8,x
 and (msk),y
 ora (hlp),y
 sta bshp+35+8,x
 iny
 lda bshp+36+8,x
 and (msk),y
 ora (hlp),y
 sta bshp+36+8,x
 iny
 lda bshp+37+8,x
 and (msk),y
 ora (hlp),y
 sta bshp+37+8,x
 iny
 lda bshp+38+8,x
 and (msk),y
 ora (hlp),y
 sta bshp+38+8,x
 iny
 lda bshp+39+8,x
 and (msk),y
 ora (hlp),y
 sta bshp+39+8,x

;--- przepisz bufor na znaki

 ldy #0       ;lewa gora
 lda bshp
 sta (tmp),y
 lda bshp+8
 sta (bak),y
 iny
 lda bshp+1
 sta (tmp),y
 lda bshp+9
 sta (bak),y
 iny
 lda bshp+2
 sta (tmp),y
 lda bshp+10
 sta (bak),y
 iny
 lda bshp+3
 sta (tmp),y
 lda bshp+11
 sta (bak),y
 iny
 lda bshp+4
 sta (tmp),y
 lda bshp+12
 sta (bak),y
 iny
 lda bshp+5
 sta (tmp),y
 lda bshp+13
 sta (bak),y
 iny
 lda bshp+6
 sta (tmp),y
 lda bshp+14
 sta (bak),y
 iny
 lda bshp+7
 sta (tmp),y
 lda bshp+15
 sta (bak),y

 ldy #16      ;lewy dol
 lda bshp+16
 sta (tmp),y
 lda bshp+24
 sta (bak),y
 iny
 lda bshp+17
 sta (tmp),y
 lda bshp+25
 sta (bak),y
 iny
 lda bshp+18
 sta (tmp),y
 lda bshp+26
 sta (bak),y
 iny
 lda bshp+19
 sta (tmp),y
 lda bshp+27
 sta (bak),y
 iny
 lda bshp+20
 sta (tmp),y
 lda bshp+28
 sta (bak),y
 iny
 lda bshp+21
 sta (tmp),y
 lda bshp+29
 sta (bak),y
 iny
 lda bshp+22
 sta (tmp),y
 lda bshp+30
 sta (bak),y
 iny
 lda bshp+23
 sta (tmp),y
 lda bshp+31
 sta (bak),y

 ldy #8      ;prawa gora
 lda bshp+32
 sta (tmp),y
 lda bshp+40
 sta (bak),y
 iny
 lda bshp+33
 sta (tmp),y
 lda bshp+41
 sta (bak),y
 iny
 lda bshp+34
 sta (tmp),y
 lda bshp+42
 sta (bak),y
 iny
 lda bshp+35
 sta (tmp),y
 lda bshp+43
 sta (bak),y
 iny
 lda bshp+36
 sta (tmp),y
 lda bshp+44
 sta (bak),y
 iny
 lda bshp+37
 sta (tmp),y
 lda bshp+45
 sta (bak),y
 iny
 lda bshp+38
 sta (tmp),y
 lda bshp+46
 sta (bak),y
 iny
 lda bshp+39
 sta (tmp),y
 lda bshp+47
 sta (bak),y

 ldy #24      ;prawy dol
 lda bshp+48
 sta (tmp),y
 lda bshp+56
 sta (bak),y
 iny
 lda bshp+49
 sta (tmp),y
 lda bshp+57
 sta (bak),y
 iny
 lda bshp+50
 sta (tmp),y
 lda bshp+58
 sta (bak),y
 iny
 lda bshp+51
 sta (tmp),y
 lda bshp+59
 sta (bak),y
 iny
 lda bshp+52
 sta (tmp),y
 lda bshp+60
 sta (bak),y
 iny
 lda bshp+53
 sta (tmp),y
 lda bshp+61
 sta (bak),y
 iny
 lda bshp+54
 sta (tmp),y
 lda bshp+62
 sta (bak),y
 iny
 lda bshp+55
 sta (tmp),y
 lda bshp+63
 sta (bak),y

;---

 ldx shp
 ldy xcsh+14,x
 lda char
; ora xcsh+16,x    ;czy invers ?
 clc
 sta (pom),y
 adc #1
 iny
 sta (pom),y
 adc #1
 ldy #32
 sta (pom),y
 adc #1
 iny
 sta (pom),y
 jmp licz

;--- adresy

adres ldx xcsh+12,y
 lda lshp,x    ;nowy adres klatki
 clc
 adc xcsh+8,y  ;adres bazowy
 sta hlp
 lda hshp,x
 adc xcsh+9,y
 sta hlp+1

 ldx xcsh+3,y
ttab lda $ffff,x
 sta fza+1     ;zapamietaj nr klatki
 clc           ;adres klatki
 adc hlp       ;+faza (0..3)
 sta hlp
 bcc _t0
 inc hlp+1

_t0
; lda hlp       ;adres maski
 sta msk
 lda hlp+1
 ora #4
 sta msk+1
 rts

;-------;
* ODDAJ *
;-------;
oddajQ sta xcsh+23,x
oddajQ_ rts
oddaj sty rob
 lda xcsh+23,y
 bne oddajQ_
 
 ldx xcsh+4,y
 lda l_adr,x
 sta pom
 lda h_adr,x
 sta pom+1
 
 ldx xcsh+24,y
 lda death,x		;usun stare zaznaczenie pola smierci
 and #%11111101
 sta death,x

 lda xcsh+2,y
; beq od_
; cmp #1
; beq od_
 cmp #2
 bcc od_
 cmp #$ff
 beq od_

 ldx rob        ;pion oddaj
 ldy xcsh+15,x
 lda xcsh+5,x
 sta (pom),y
 iny
 lda xcsh+6,x
 sta (pom),y
 ldy #32
 lda xcsh+7,x
 sta (pom),y
 iny
 lda xcsh+19,x
 sta (pom),y
 
 lda xcsh+22,x
 bne oddajQ
 jmp ctrl

od_ ldx rob
 ldy xcsh+15,x
 lda xcsh+5,x
 sta (pom),y
 iny
 lda xcsh+6,x
 sta (pom),y
 iny
 lda xcsh+7,x
 sta (pom),y
 
 lda xcsh+22,x
 bne oddajQ
; jmp ctrl

;---

ctrl lda xcsh+20,x	;sprawdz czy sie rusza
 beq *+3
ctrlQ rts

 lda xcsh+21,x		;czy oberwal i niech sie juz nie rusza
 bne ctrlQ

 lda xcsh+2,x
 sta kier
 lda xcsh,x
 sta sx
 sta bak
 lda #0
 sta tmp	;nowy kierunek
 sta bak+1	;czy byl?

 lda kier
 cmp #1
 bne _n
 inc sx
 jmp los
_n cmp #$10
 bne los
 clc
 adc sx
 sta sx

los lda xcsh+9,x
 cmp >gab
 bne zarow

;------------;
* TEST GABKI *
;------------;
gabka ldy #0 
 sty tRuch
 sty tRuch+1
 sty tRuch+2
 sty tRuch+3
 
 ldx sx
 lda map-1,x
 cmp #_bmb
 beq z01_
 cmp #_mur2
 beq z01_
 lda #$ff
 sta tRuch,y
 iny
 
z01_ lda map+1,x
 cmp #_bmb
 beq z02_
 cmp #_mur2
 beq z02_
 lda #1
 sta tRuch,y
 iny

z02_ lda map+16,x
 cmp #_bmb
 beq z03_
 cmp #_mur2
 beq z03_
 lda #$10
 sta tRuch,y
 iny

z03_ lda map-16,x
 cmp #_bmb
 beq _tz_
 cmp #_mur2
 beq _tz_
 lda #$f0
 sta tRuch,y
 iny
 
_tz_ tya
; lda #1

 beq zarQ		;jesli =0 brak ruchu
 cmp #1
 beq _tz_one		;tylko jedna mozliwosc ruchu
 clc
 adc >tAruch-$200
 sta _tz_l+2

 ldy $d20a
_tz_l ldx $ff00,y
 lda tRuch,x
 jmp t_s

_tz_one lda tRuch
; lda #$f0
 jmp t_s

;--------------;
* TEST ZAROWKI *
;--------------;
zarQ jmp zr_
zarow ldy #0
 sty tRuch
 sty tRuch+1
 sty tRuch+2
 sty tRuch+3
 
 ldx sx		;niech nie wlazi na 2 gorne poziomy
; cpx #48+16
; bcc z00

z03 lda map-16,x
 cmp #_bmb
 beq z00
 and #$7f
 cmp #_mur1+1
 bcc z00
 lda #$f0
 sta tRuch,y
 iny
 
z00 lda map-1,x
 cmp #_bmb
 beq z01
 and #$7f
 cmp #_mur1+1
 bcc z01
 lda #$ff
 sta tRuch,y
 iny
 
z01 lda map+1,x
 cmp #_bmb
 beq z02
 and #$7f
 cmp #_mur1+1
 bcc z02
 lda #1
 sta tRuch,y
 iny

z02 lda map+16,x
 cmp #_bmb
 beq tz_
 and #$7f
 cmp #_mur1+1
 bcc tz_
 lda #$10
 sta tRuch,y
 iny

tz_ tya
; lda #1

 beq zarQ		;jesli =0 brak ruchu
 cmp #1
 beq tz_one		;tylko jedna mozliwosc ruchu
 clc
 adc >tAruch-$200
 sta tz_l+2
 
 ldy $d20a
tz_l ldx $ff00,y
 lda tRuch,x
 bne t_s
 
tz_one lda tRuch
; lda #$10

;--- dla zarowki PION

t_s sta tmp
 ldx rob
 lda bak
 sta xcsh,x
 lda tmp
 sta xcsh+2,x
 cmp kier
 beq xi_

 lda #0		;ktora polowka znaku
 sta xcsh+14,x
 
 lda tmp
 cmp #$f0	;jesli stal i chce
 beq _f0	;w dol
 cmp #$01
 beq _01
 cmp #$10
 beq _10
 cmp #$ff
 beq _ff

_f0 lda kier	;w gore
 cmp #0
 bne _10
 lda tmp
 jmp xi2_

_10 lda kier	;w dol
 cmp #1
 bne _0_
 clc
 adc xcsh,x
 sta xcsh,x
_0_ lda kier	;z ruchu poziomego
 cmp #$ff	;w gore
 beq uu_
 cmp #1
 beq uu_
_q_ rts
uu_ lda tmp
 cmp #$f0
 bne _q_
xi2_ clc
 adc xcsh,x
 sta xcsh,x
 rts
xi_ lda xcsh,x
 clc
 adc kier
 sta xcsh,x
 rts

;--- POZIOM

_ff lda kier	;w lewo
 cmp #0
 bne _01
 lda #$ff
 jmp s3__

_01 lda kier	;w prawo
 cmp #$10
 bne _1_
 clc
 adc xcsh,x
 sta xcsh,x

_1_ lda kier	;z ruchu pionowego
 cmp #$10	;w lewo
 beq ll_
 cmp #$f0
 beq ll_
_2_ lda tmp
 cmp #1
 beq pr_
 cmp #$ff
 beq le_
 rts
ll_ lda tmp
 cmp #$ff
 bne _2_
s3__ clc
 adc xcsh,x  ;lewo
 sta xcsh,x

le_ lda #1
 sta xcsh+14,x
 rts
pr_ lda #0
 sta xcsh+14,x
_q2_ rts

zr_ ldx rob
 lda kier
 cmp #1
 beq zr_p
 cmp #$ff
 beq zr_l
 cmp #$10
 beq zr_p
 
zr_l lda #0
 sta xcsh+2,x
 sta xcsh+14,x
 rts

zr_p add xcsh,x
 sta xcsh,x
 sta xcsh+4,x
 lda #0
 sta xcsh+2,x
 rts
 
;---

IniPrgSprt ldy #$7f
af tya			;adresy znakow 0-127
 pha
 lsr @
 lsr @
 lsr @
 lsr @
 lsr @
 clc
 adc >fnt
 sta hfnt,y
 sta hfnt+$80,y
 pla
 and #$1f
 asl @
 asl @
 asl @
 sta lfnt,y
 sta lfnt+$80,y
 dey
 bpl af

; jsr clrSprite
 
 lda #2
 sta xcsh+13
 sta xcsh+13+len
 lda #4
 sta xcsh+13+len*2
 sta xcsh+13+len*3
 lda #$60		; znaki ktore beda modyfikowane
 sta xcsh+1
 lda #$64
 sta xcsh+1+len
 lda #$68
 sta xcsh+1+len*2
 lda #$6c
 sta xcsh+1+len*3
 lda <gab
 sta xcsh+8
 sta xcsh+8+len
 lda >gab
 sta xcsh+8+1
 sta xcsh+8+len+1

 lda <zar
 sta xcsh+8+len*2
 sta xcsh+8+len*3
 lda >zar
 sta xcsh+8+len*2+1
 sta xcsh+8+len*3+1
 
 lda <gab_ex
 sta xcsh+27
 sta xcsh+27+len
 lda >gab_ex
 sta xcsh+27+1
 sta xcsh+27+len+1

 lda <zar_ex
 sta xcsh+27+len*2
 sta xcsh+27+len*3
 lda >zar_ex
 sta xcsh+27+len*2+1
 sta xcsh+27+len*3+1
 
 ldy #0
 jsr putSprite
 ldy #len
 jsr putSprite
 ldy #len*2
 jsr putSprite
 ldy #len*3
 jsr putSprite

putQ rts

;---
;---

iniSprVal lda #_nic
 sta xcsh+5,y
 sta xcsh+6,y
 sta xcsh+7,y
 sta xcsh+19,y
 sty hlp+1
  
 lda #5
 sta xcsh+11,y
 lda #11
 sta xcsh+18,y
 lda #1
 sta xcsh+20,y
; lda #0
; sta xcsh+21,y
; sta xcsh+22,y
; sta xcsh+23,y
 
 lda #0
 sta hlp
 rts

;---

putSprite jsr iniSprVal
 
putL ldx #0
 ldy #48
w_w lda map,y
 cmp #_mur2
 beq sw_w

 sta $d40a
 lda $d20a	;losuj mur
 cmp #252	;powyzej wartosci
 bcc sw_w
 lda hlp
 bne putQ
 sty bak
 
 lda map+1,y
 cmp #_mur2
 beq sw_w
 
 lda #_nic
 sta map,y
 sta map+1,y

 ldy hlp+1
 lda bak
 sta xcsh,y
 sta xcsh+4,y
 sta xcsh+24,y
 inc hlp
 
sw_w iny
 cpy #160
 beq putL
 inx
 cpx #sz_scr-1
 bne w_w

 ldx #0
 iny
 cpy #160
 bne w_w
 jmp putL

;---

iniGra lda <ant
 sta _560+1
 lda >ant
 sta _561+1
 lda #%00111101
 sta _559+1

; lda #$00		;kolory gornego paska /BAR/
; sta _712
; lda #$0a
; sta _708
; lda #$a6
; sta _709
; lda #$16
; sta _710
; lda #$0f
; sta _711
 rts

;---

iniMsx sta iniM
 lda #$70
 ldx >muza
 ldy <muza
 jsr player

 ldx #0		;TMC
 txa
 jsr player
 lda #$10
 ldx #0
iniM equ *-1
 jsr player
 rts

;---
;- detekcja kolizji sprite -> sprite
;- jesli naszly na siebie i ktorys z nich ma czache to obaj beda zarazeni czacha
;- jesli obaj maja juz czache to olej ich
;---

kolizja lda #0
 beq cont

 ldy #0
 sty $d01e	;skasowanie rejestru kolizji 
 sty kolizja+1

 lda csh+13
 cmp csh+13+siz
 beq cont
 
; lda csh+13	;czy obaj maja wlaczone czache
; beq k00
; iny
;k00 lda csh+13+siz
; beq k01
; iny
;k01 cpy #1
; bne cont
 
; beq cont	;zaden nie ma czachy
; cmp #2
; beq cont	;obaj maja czachy

*- Y to gracz ktory zaraza
*- X to nowy zarazony gracz  
 ldy #0
 ldx #siz
 lda csh+13,y	;czy 1-y gracz ma czache
 bne obdarz
 ldy #siz
 ldx #0
 
obdarz lda #1	;zarazenie nowego gracza 
 sta csh+13,x

 lda csh+12,y	;przepisz repe+1 od gracza zarazonego
 sta csh+12,x
 lda csh+18,y	;oraz sra+1
 sta csh+18,x

 lda csh+8,x	;zapamietaj mbmb
 sta csh+16,x
 lda csh+9,x	;i moc
 sta csh+17,x

 lda csh+8,y	;przepisz mbmb od gracza zarazonego
 sta csh+8,x
 lda csh+9,y	;oraz moc
 sta csh+9,x

 lda #0		;wyzeruj licznik nowemu posiadaczowi czaszki
 sta csh+14,x
 sta csh+15,x

cont rts

;---

msxStop lda #$60
 sta player+3
 ldy #8			;muza stop
 lda #0
sil sta $d200,y
 sta $d210,y
 dey
 bpl sil
 sta tab_sfx+0
 sta tab_sfx+1
 sta tab_sfx+2
 sta tab_sfx+3
 lda #3
 sta $d20f
 sta $d21f 
 rts

;---

msxDepack
; lda <dumpPck
; ldx >dumpPck
 jmp _dep
 
dumpDepack
 lda <dumpPck
 ldx >dumpPck
_dep
 ldy >muza	; rozpakuj dump
 sty adr_out+1
 jsr rozpakuj
 lda >Proc	; zwroc starszy bajt adresu docelowego miejsca
 sta adr_out+1
 rts

;---

rozpakuj sta tmpA+1
 stx tmpB+1
 
 jsr msxStop
 jsr wai
 
 lda #0
 sta $d40e
 sta $d400
 sta _559+1
 ldy #8
cp_ sta $d000,y
 dey
 bpl cp_
 
 ldy #$f                ;zapamietaj bajty $f0-$ff
cp0 lda zpage,y
 sta temp,y
 dey
 bpl cp0

tmpA lda #0
 sta inputPointer
tmpB lda #0
 sta inputPointer+1 
 
 lda <Proc
 sta outputPointer
adr_out lda >Proc
 sta outputPointer+1
 
 jsr inflate

 ldy #$f                ;oddaj bajty $f0-$ff
cp1 lda temp,y
 sta zpage,y
 dey
 bpl cp1
 
 lda #$c0
 sta $d40e
 rts 

;---

copy equ $bc0

copy_proc2bufor
 lda <copy
 sta src+1
 ldx >copy
 ldy >bufor
 lda #4
 jmp move

copy_bufor2proc
 lda <copy
 sta dst+1
 ldx >bufor
 ldy >copy
 lda #4
 jmp move

;---

tjump dta l(_slw,_fst,_sra,_fzr,_fmn,_max,_nul,_nul)

;---

dekompresor
 icl 'inflate/inflate2.asm'

;---
;--- efekty dzwiekowe, do przepisania pod $200
;---
copy_SFX
 ldy #0
 tya
cl_ sta bum,y
 iny
 bne cl_

 ldy #$7f
cp_sfx lda bum_cp,y
 sta bum,y
 lda bum_cp_,y
 sta bum+$80,y
 dey
 bpl cp_sfx

; ldy #0 
;cp_sfx_ lda tik_cp,y    ; efekt polozenia bomby i zebrania ikonki razem
; sta tik,y
; lda tik_cp_,y
; sta tik+$80,y
; iny
; cpy #64
; bne cp_sfx_
 rts

;tik_cp
; dta b(0,0,14,14,14,14,0,0,0,0,0,0,0,0,0,0)
;iko_cp
; dta b(0,39,39,39,39,39,60,60,60,60,60,60,29,29,29,29)
; dta b(29,60,60,60,60,60,60,60,60,60,60,60,60,60,60,60)
; dta b(60,60,60,60,60,60,60,60,60,60,60,0,0,0,0,0)

;tik_cp_
; dta b(0,0,163,162,160,160,0,0,0,0,0,0,0,0,0,0)
;iko_cp_
; dta b(0,174,170,166,163,161,171,167,164,162,161,160,162,161,161,160)
; dta b(160,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)
; dta b(0,0,0,0,0,0,0,0,0,0,0,0,0,0,0,0)


;--- pozostale pliki spakowane do 'PACK.DEF'

;---
;- SPR to dane zarowki, SPR_ dane maski dla zarowki
;- SPR2 to dane gabki, SPR2_ dane maski dla gabki
;---

; org zar		; $9000         spakowane do pliku 'spr.def'
; ins 'spr.dat'		;org zar

; org zar+$400-6
; ins 'spr_.dat		;org zar+$400

; org gab
; ins 'spr2.dat'	;org gab

; org gab+$400
; ins 'spr2_.dat'	;org gab+$400
 
;---
; org fnt                ; $a000
; ins 'dyna2.fnt',6,2048

; org buf0
; ins 'dyna.pmg',6,2048

;--- $B000...
;---
; org gab_ex		; spakowane do pliku 'spr_ex.def'
; ins 'egab_.dat'
; org gab_ex+$400
; ins 'egab.dat'
  
; org zar_ex
; ins 'ezar_.dat'
; org zar_ex+$400
; ins 'ezar.dat'

;---
 org $bf00              ; przejsciowy obszar

bum_cp
 dta b(0,56,56,56,56,56,208,240,248,161,128,208,96,64,64,64)
 dta b(64,64,64,64,64,64,53,53,53,53,50,50,50,50,47,47)
 dta b(47,47,44,0,0,0,0,0,0,0,0,0,0,0,0,0)

 dta $00,$6b,$6b,$d7,$d7,$d7,$5f,$5f,$5f,$c0,$c0,$c0,$50,$50,$50,$a1,$a1
 dta $a1,$78,$78,$78,$f1,$f1,$f1,$6b,$6b,$6b,$d7,$d7,$d7,$5f,$5f,$5f
 dta $c0,$c0,$c0,$50,$50,$50,$a1,$a1,$a1,$78,$78,$78,$f1,$f1,$f1,$6b
 dta $6b,$6b,$d7,$d7,$d7,$5f,$5f,$5f,$c0,$c0,$c0,$50,$50,$50,$a1,$a1
 dta $a1,$78,$78,$78,$f1,$f1,$f1,$6b,$6b,$6b,$d7,$d7,$d7,$00,$00

bum_cp_
 dta b(0,132,133,131,130,1,175,175,173,134,142,140,138,136,134,133)
 dta b(132,131,130,130,129,130,130,130,130,130,130,130,129,129,129,129)
 dta b(129,129,129,128,128,128,128,128,128,128,128,128,128,128,128,0)

 dta $00,$a6,$a6,$a6,$a6,$a6,$a5,$a5,$a5,$a5,$a5,$a5,$a5,$a5,$a5,$a5,$a5
 dta $a5,$a5,$a5,$a5,$a5,$a4,$a4,$a4,$a4,$a4,$a4,$a4,$a4,$a4,$a4,$a4
 dta $a4,$a4,$a4,$a4,$a4,$a3,$a3,$a3,$a3,$a3,$a3,$a3,$a3,$a3,$a3,$a3
 dta $a3,$a3,$a3,$a3,$a3,$a2,$a2,$a2,$a2,$a2,$a2,$a2,$a2,$a2,$a2,$a2
 dta $a2,$a2,$a2,$a2,$a2,$a1,$a1,$a1,$a1,$a1,$a1,$a1,$a1,$00,$00

 opt o-
 org $bf00
;---
; xcsh pozycja poczatkowa
; xcsh+0, xcsh+4 index pozycji poczatkowej

; xcsh+5,6,7 znaki pod spritem
; xcsh+8,9   adres klatek animacji
; xcsh+10    licznik opoznienia
; xcsh+11    max wartosc licznika opoznienia
; xcsh+12    ktora klatka animacji
; xcsh+13    max klatek animacji
; xcsh+14,15 pozycja na ktorej znajduja sie znaki sprita ?
; xcsh+20    czy sprawdzac ruch
; xcsh+24    zapamietaj gdzie postawiles znacznik pola smierci
;---
xcsh dta b(0),b($60),b(0),b(0),b(0)
     dta d'$$$',a(gab),b(0),b(5),b(0)
     dta b(2),b(0),b(0),b(0),b(0),b(11)
     dta d'$',b(1),b(0,0,0,0,0,0)
     dta a(gab_ex)

     dta b(0),b($64),b(0),b(0),b(0)
     dta d'$$$',a(gab),b(0),b(5),b(0)
     dta b(2),b(0),b(0),b(0),b(0),b(11)
     dta d'$',b(1),b(0,0,0,0,0,0)
     dta a(gab_ex)

     dta b(0),b($68),b(0),b(0),b(0)
     dta d'$$$',a(zar),b(0),b(5),b(0)
     dta b(4),b(0),b(0),b(0),b(0),b(11)
     dta d'$',b(1),b(0,0,0,0,0,0)
     dta a(zar_ex)

     dta b(0),b($6c),b(0),b(0),b(0)
     dta d'$$$',a(zar),b(0),b(5),b(0)
     dta b(4),b(0),b(0),b(0),b(0),b(11)
     dta d'$',b(1),b(0,0,0,0,0,0)
     dta a(zar_ex)

;---
 opt o+
 run main

 end
